static char *cvs_id =" $Id: xnd_brg.c,v 1.2 2002/01/10 15:24:41 berar Exp $ ";
/* XND_BRG  Calcul R_Bragg ... */

#define  USE_RBRG
#define  USE_BRAGG
#define  USE_MODUL
#define  USE_SCAN
#define  USE_EXPER
#define  USE_PHASE
#define  USE_PSEUDO
#include "../xnd_def.h"
#include "../xnd_cah.h"
#include "../xnd_mem.h"
#include <string.h>

#ifdef fseek
#undef fseek
#endif
/* ----------------------------------------------------------- */
TYPE_BRAGG *act, *default_bragg;
TYPE_RBRG  o_brg ;  	/* overall Bragg factors, used at last cycle */
/* ----------------------------------------------------------- */
/* the following use the current line pointer : act */
void  brg_ini_iobs PROTO((void));
void  brg_add_pts  PROTO((int pos, float ical, float isum));
float brg_get_iobs PROTO((TYPE_RBRG *one, int do_fobs));
/* ----------------------------------------------------------- */
#ifndef SEEK_SET
#define SEEK_SET 0
#endif
/* ----------------------------------------------------------- */
#ifndef THINK_C
int compare_bragg(P_(const void *) p1, P_(const void *) p2)
#else
int compare_bragg(P_(void *) p1, P_(void *) p2)
#endif
#ifdef NO_PROTO
void *p1, *p2;
#endif
{   float dif;
    dif =  ((TYPE_BRAGG *) p1)->dtheta - ((TYPE_BRAGG *) p2)->dtheta;
    if (dif>0) return (1);
    if (dif<0) return(-1);
    return(0);
    }
/* ----------------------------------------------------------- */
void brg_file(P_(void))
{   int   i, j;
	 float asym;
	 TYPE_RBRG one;
    TYPE_RBRG brg, *p_brg ;
    float swobs;
    TYPE_BRAGG *bragg, *l_bragg;
    char  *v_bragg;   /* the bragg struct size may vary */
    int  fprecis, iprecis, cprecis;
    char qualite;
    char txt[15];
    int n_strong = 0;

    if (prt_hkl <= 0 || hkl_fich == NULL )
    {   brg_residual();
        return;
        }
    push_err_msg("brg_file (xnd_brg.c)");
    fprintf (list_fich, "\n");
    p_brg = (TYPE_RBRG *) tst_alloc(tot_phase,sizeof(TYPE_RBRG), "R Bragg phase");
	 memset( &brg, 0, sizeof(TYPE_RBRG));
	 memset( p_brg, 0, sizeof(TYPE_RBRG)*tot_phase);
    if (dim_bragg == 0)
    {  fprintf (list_fich,"no lines for Bragg calculation\n");
       return;
       }
    if (dim_bragg > MAX_ALLOC / bragg_size)
    {   fprintf (list_fich," Too much Bragg lines for allocating memory : %d",
        dim_bragg);
        dim_bragg = MAX_ALLOC / bragg_size;
        fprintf (list_fich, " truncated at %d\n", dim_bragg);
        }

    l_bragg = bragg = (TYPE_BRAGG *) malloc(dim_bragg * bragg_size);
    if (l_bragg == NULL)
    {  fprintf (list_fich,"enable to allocate memory for Bragg calculation\n");
       return;
       }
    if (fseek(bragg_fich, 0, SEEK_SET)!=0)
    {  fprintf (list_fich,"seek error in the Bragg file\n");
       return;
       }
    push_err_msg("fread");
    for (i=0, v_bragg=(char*)bragg; i<dim_bragg; i++, v_bragg+=bragg_size)
    if (fread (v_bragg, bragg_size, 1, bragg_fich) !=1)
    {  fprintf (list_fich,"error reading Bragg file at line %d\n", i);
       return;
       }
    v_bragg = (char*)bragg;
    pop_err_msg();    
    if ((prt_hkl & 8) == 0)
    {   push_err_msg("2theta qsort, see 'bragg_size' definition in xnd_ips.c");
        qsort (v_bragg, dim_bragg, bragg_size, compare_bragg);
        pop_err_msg();
        }
    fprintf (hkl_fich,"#%s a %f\n#     p   h  k  l", l_exper->nom,l_diag->temp);
    for (i=0;i<prt_modsize;i++) fprintf (hkl_fich," m%d", i+1);
    fprintf (hkl_fich,"      2theta    i_obs i_calc (   f_a     f_b )");
    if (dif_nature == EXPER_RXA) fprintf (hkl_fich,"( fano_a fano_b )");
    fprintf (hkl_fich,"   w_l   w_g    as_1 as_3 mu orien cor d_hkl   s_i\n");

    for (i=0, v_bragg=(char*)bragg; i<dim_bragg; i++, v_bragg+=bragg_size)
    { act = l_bragg =(TYPE_BRAGG *)v_bragg;
		memset (&one, 0, sizeof(TYPE_RBRG));
     brg_ini_iobs();
     brg_get_iobs(&one, ( act->mu>0 ));
     brg_add_hkl(&brg, &one);
     if (p_brg)	brg_add_hkl(p_brg+act->phase, &one);
     if (one.io > 0) swobs = sqrt(one.wio/one.io);
     qualite = 'f';
     if (one.io > 0)
     {  j = floor(100.0 * fabs ((act->s_o1-act->s_o2)/(act->s_o1+act->s_o2)));
        if (j < 1)  qualite =  'a';    /* 2% */
        else if (j < 2) qualite = 'b';
        else if (j < 4) qualite = 'c';
        else if (j < 8) qualite = 'd';
        else if (j < 16) qualite = 'e';
        }
         if (act->mu < 0) act->mu = - act->mu;
        iprecis = (one.io >= 10000 || I_C >= 10000 ) ? 0 : 1;
         if (one.io < 100 && I_C < 100 ) iprecis = 2;
         fprecis = (l_exper->nature) ? 1 : 0;
         if ( act->cor >= 100.0 ) cprecis = 0;
         else if ( act->cor >= 100.0 ) cprecis = 1;
         else cprecis = 1;
         fprintf (hkl_fich,"%4d (%d)%3d", i, act->phase, H);
         if (pseudo_phase[act->phase].phase->nature == PHASE_PARASITE )
                fprintf (hkl_fich,"  -  -");
          else  fprintf (hkl_fich,"%3d%3d", K, L);
          current_modul = pseudo_phase[act->phase].modul;
          if (current_modul==NULL || current_modul->size == 0 ) for (j=0;j<prt_modsize;j++) 
                fprintf (hkl_fich,"  -");
          else for (j=0;j<prt_modsize;j++) 
             if (j<current_modul->size)   fprintf (hkl_fich,"%3d", act->h[3+j]);
             else   fprintf (hkl_fich,"  -");
          fprintf (hkl_fich," (%d) %7.3f %c %6.*f %6.*f (%7.*f %7.*f)",
          act->lambda, DTH, qualite, iprecis, one.io, iprecis, I_C, fprecis, F_A, fprecis, F_B);
          if (dif_nature == EXPER_RXA) fprintf (hkl_fich,"(%7.*f %7.*f)",
          fprecis, act->f_abm[0], fprecis, act->f_abm[1]);
          fprintf (hkl_fich,"  %5.3f %5.3f  % 5.2f% 5.2f %2d %4.2f %4.*f %6.*f %4.*f %6.2f%6.2f\n",
          W_L, W_G, act->asym[0], act->asym[1], act->mu, act->orien,
             cprecis , act->cor ,act->dist > 10.0 ? 3 : 4 , act->dist, 
             iprecis, swobs, l_diag->points[act->deb], l_diag->points[act->fin]);

      for (j = 0, asym = 0; j < max_asym; j++) asym += fabs(act->asym[j]);
      if ( fabs(asym) > 1 && n_strong < 3 )
      {    n_strong++;
           fprintf (list_fich,"ASYM : %4d (%d)%3d%3d%3d (%d) %7.3f asym ",
             i, act->phase, H, K, L, act->lambda, DTH);
           for (j = 0; j < max_asym; j++)  fprintf (list_fich," %5.2f ", act->asym[j]);
           fprintf (list_fich," is strong, meaningless points may appear\n");
           if (n_strong == 3) fprintf (list_fich,"ASYM : further warning not printed\n\n");
           }
      }
   if (prt_cif && prt_cif != -1)
	{	cif_fich = tst_open (cif_name,"a","CIF file");
	   fprintf(cif_fich,"# ---------------------------------\n");
	   fprintf(cif_fich,"# residual factor infos used by cif\n");
	   fprintf(cif_fich,"# ---------------------------------\n");
	   }
	 if (tot_phase>1) for (i=0;i<tot_phase;i++)
    {   sprintf (txt, " PHASE #%d", i);
        brg_fprintf (list_fich, txt, p_brg+i);
        }
    free (p_brg);
    brg_fprintf (list_fich, "\n         ", &brg);
    brg_add_hkl ( &o_brg, &brg);
    if (prt_cif && prt_cif != -1)
    {   cif_fich = xclose(cif_fich); }
	 pop_err_msg();
    }
/* ----------------------------------------------------------- */
void brg_residual(P_(void))
{   int   i;
	 TYPE_RBRG one;
    TYPE_RBRG brg, *p_brg ;

    push_err_msg("brg_residual (xnd_brg.c)");
    fprintf (list_fich, "\n");
    p_brg = (TYPE_RBRG *) tst_alloc(tot_phase,sizeof(TYPE_RBRG), "R Bragg phase");
	 memset( &brg, 0, sizeof(TYPE_RBRG));
	 memset( p_brg, 0, sizeof(TYPE_RBRG)*tot_phase);

    if (dim_bragg == 0)
    {  fprintf (list_fich,"no lines for Bragg calculation\n");
       return;
       }
    if (fseek(bragg_fich, 0, SEEK_SET)!=0)
    {  fprintf (list_fich,"seek error in the Bragg file\n");
       return;
       }
    act = default_bragg;
    for (i=0; i<dim_bragg; i++)
    {  if (fread (act, bragg_size, 1, bragg_fich) !=1)
       {  fprintf (list_fich,"error reading Bragg file at line %d\n", i);
          return;
          }
		 memset (&one, 0, sizeof(TYPE_RBRG));
       brg_ini_iobs();
       brg_get_iobs(&one, ( act->mu>0 ));
		 brg_add_hkl(&brg, &one);
       if (p_brg)	brg_add_hkl(p_brg+act->phase, &one);
       }
    if (tot_phase>1) for (i=0;i<tot_phase;i++)
    {   char txt[15];
        sprintf (txt, " PHASE #%d", i);
        brg_fprintf (list_fich, txt, p_brg+i);
        }
    free (p_brg);
    brg_fprintf (list_fich, "\n         ", &brg);
    brg_add_hkl ( &o_brg, &brg);
    pop_err_msg();
    }
/* ----------------------------------------------------------- */
void brg_ini_residual (P_(TYPE_RBRG *) brg)
#ifdef NO_PROTO
TYPE_RBRG *brg;
#endif
{	 memset( brg, 0, sizeof(TYPE_RBRG));
   }
/* ----------------------------------------------------------- */
void brg_add_hkl (P_(TYPE_RBRG *) brg, P_(TYPE_RBRG *) one)
#ifdef NO_PROTO
TYPE_RBRG *brg, *one;
#endif
{  brg->io += one->io;
   brg->di += one->di;
   brg->wio += one->wio;
   brg->wdi += one->wdi;
   brg->ni += one->ni;
   brg->fo += one->fo;
   brg->df += one->df;
   brg->wfo += one->wfo;
   brg->wdf += one->wdf;
   brg->nf += one->nf;
   }
/* ----------------------------------------------------------- */
void brg_ini_iobs(void)
{ 	int pos;
   act->s_o1 = act->s_o2 = act->s_c1 = act->s_c2 = act->s_w = act->s_n = 0;
   if ( asym_mode == 0 )
   {  cotan_2t = 1/tan(RAD * DTH);
      cos_2t = cos(RAD * DTH);
      }
  ini_profil ();
  if (influence)
  {  pos = act->deb;
     l_points = &l_diag->points[pos];
     if (pos<n_pts)
     while (pos<=act->fin)
     {  dt = *l_points-DTH;
        brg_add_pts(pos, profil(), get_ical(pos));
        l_points++;
        pos++;
        }
    }
  }
/* ----------------------------------------------------------- */
void brg_add_pts(int pos, float ical, float isum) 
{   float pobs, wobs;
    float dd, dg, dl;
	 pobs = get_iobs(pos) - get_ibkg(pos);
	 pobs *= (isum > EPSILON) ? ical / isum : 1;
    dg = (pos!=0) ? *l_points - *(l_points-1) : 0;
    dl = (pos!=n_pts-1) ? *(l_points+1) - *l_points : 0;
    if ((dl >0) && (dg > 2*dl) && (pos==act->deb)) dg = dl;
    else  if ((dg >0) && (dl > 2*dg) && (pos==act->fin)) dl= dg;
    dd = 0.5 * (dg+dl);
    pobs *= dd;
    ical *= dd;
    act->s_o1 += pobs;
    act->s_o2 += pobs * ical;
    act->s_c1 += ical;
    act->s_c2 += ical * ical;
	 act->s_n++;
    /* estimation large de io : ratio non utilise */
    wobs = get_wght(pos);
    if ( wobs > EPSILON ) act->s_w += dd *dd / wobs;
  }
/* ----------------------------------------------------------- */
float brg_get_iobs(TYPE_RBRG *one, int do_fobs)
{  float wobs;
   memset (one, 0, sizeof(TYPE_RBRG));
	if (act->s_n == 0) return 0; 
   if (act->s_c1 > EPSILON)  act->s_o1 /= act->s_c1;
   if (act->s_c2 > EPSILON)  act->s_o2 /= act->s_c2;
	one->io = I_C * ( bragg_repart * act->s_o1 + (1-bragg_repart) * act->s_o2);
   if (one->io < 0 ) one->io = 0;
	if ( act->s_w > EPSILON && act->s_c1 > EPSILON )
   {  wobs =   I_C / act->s_c1 * sqrt ( act->s_w );
      wobs = 1.0 / ( wobs * wobs); 
      } else wobs = 0;
   one->di = (one->io>I_C) ? one->io - I_C : I_C - one->io;
   one->wio = one->io*one->io*wobs;
   one->wdi = one->di*one->di*wobs;
   one->ni = 1;
   if (one->io > 0 && do_fobs)
   {   float swbg, ratio = act->mu *act->cor* act->orien* act->ech;
       swbg = 4 * wobs * one->io * ratio;
       one->fo = sqrt (one->io / ratio);
       one->df = fabs (one->fo - sqrt(F_A * F_A + F_B * F_B));
       one->nf=1;
       one->wdf = swbg*one->df*one->df;
       one->wfo = swbg*one->fo * one->fo;
		 } 
   return one->io;
	} 
/* ----------------------------------------------------------- */
void brg_fprintf (P_(FILE *) file, P_(char *) txt, P_(TYPE_RBRG *) brg)
#ifdef NO_PROTO
FILE * file;
char * txt;
TYPE_RBRG brg;
#endif
{  int i;
   char * c;
   c = txt;
   while (*c == '\n') c++;
   i = strlen(c);
   if (brg->io > 0) fprintf (file,
       "%s R_Bragg=%.4f (%3d hkl, S_I=%9.3g)   Rw_B=%.4f (S_wI=%9.3g)\n",
       txt, brg->di/brg->io,  brg->ni, brg->io, sqrt(brg->wdi/brg->wio), brg->wio);
   else fprintf (file,"%s R_Bragg=***  (%3d hkl S_I=%.1f)\n",
       txt, brg->ni, brg->io);
   if (brg->nf)
   if (brg->fo > 0) fprintf (file,
       "%*s Rf=%.4f     (%3d hkl, Sf=%9.3g)   Rwf=%.4f (S_wF=%9.3g)\n",
       i, " ", brg->df/brg->fo, brg->nf, brg->fo, sqrt(brg->wdf/brg->wfo), brg->fo);
   else fprintf (file,"%*s Rf=***      (%3d hkl, Sf=%.1f)\n",
       i, " ", brg->nf, brg->fo);
   c = strstr(txt, "#");
	if (prt_cif && c)
	{	if (brg->io > 0) fprintf (cif_fich,
       " %s %.4f %3d %9.3g ",
       c+1, brg->di/brg->io,  brg->ni, brg->io);
   else fprintf (cif_fich,"## %s ? %3d %.1f ", txt, brg->ni, brg->io);
   if (brg->nf) if (brg->fo > 0) fprintf (cif_fich,
       " %.4f    %3d", brg->df/brg->fo, brg->nf);
   else fprintf (cif_fich,"  ?    %3d", brg->nf);
	fprintf (cif_fich,"\n");
	   }
   }
/* ----------------------------------------------------------- */


