static char *cvs_id =" $Id: xnd_pen.c,v 1.2 2002/01/10 15:24:42 berar Exp $ ";
/* XND_PEN  Penalisation : distances et angles ... */
/*  le terme metrique 1/2d Si Sk vi vk dgik est omis en derivees */

#define USE_VAR
#define USE_SYM
#define USE_ATOM
#define USE_PENAL
#define USE_PHASE
#include "../xnd_def.h"
#include "../xnd_cah.h"

TYPE_ATOM *atom_ptr(P_(int) num)
#ifdef NO_PROTO
int num;
#endif
{   int    i;
	if (num < l_phase->n_atom ) return (&l_phase->atom[num]);
	num -= l_phase->n_atom;
	for (i=0;i<l_phase->nb_bloc; i++)
	if (num < l_phase->bl_atom[i]) return (&l_phase->bl_relat[i][num]);
	else num -=l_phase->bl_atom[i];
	return (NULL);
	}

static int nb_atom_param (P_(TYPE_ATOM *) atom)
#ifdef NO_PROTO
TYPE_ATOM * atom;
#endif
{   int j;
	int nb=0;
	var_init(atom->x);
	VAR_io_id for (j=0;j<3;j++)
	if (var_param(j) != 0)  nb++;
	return nb;
	}

static float dist_atom (P_(TYPE_ATOM*)atom0, P_(TYPE_ATOM*)atom1,
			 P_(float *)sym_coef, P_(float*)u, P_(float*)gu)
#ifdef NO_PROTO
TYPE_ATOM *atom0, *atom1;
float *sym_coef, *u, *gu;
#endif
{   float v[3];
    int j;
    var_init(atom1->x);
    for (j=0;j<3;j++) v[j] = var_valeur (j);
    var_init(atom0->x);
    for (j=0; j<3; j++)
      u[j] = sym_coef[j] * v[0] + sym_coef[j+3] * v[1]
	   + sym_coef[j+6] * v[2] + sym_coef[j+9] - var_valeur (j);
    return ( sqrt (scalaire (u,gu,u)));
    }

/* --------------------------------------------------------------------------- */
/* calcul des penalites sur les distances et des elements de matrices associes */
static float tot_pena_dist(P_(void))
{   int idist,icoord;
    int i,j,ii,jj,jd;
    TYPE_PENAL  *p_dist;
    TYPE_COORD *coord;
    float tot=0;
    float u[3],gu[3],sgu[3];
    float *sym_coef;
    float d,e,d0,s0;
    TYPE_ATOM  *atom0, *atom1;
    float *deriv, *l_deriv;
    int   d_size, *ideriv, *jderiv;

    p_dist = l_phase->dist;
    for (idist=0;idist<l_phase->nb_dist;idist++,p_dist++)
    {   var_init(p_dist->dist);
	d0 = var_valeur (0);
	s0 = p_dist->sigma;
	coord = p_dist->coord;
	for (icoord=0;icoord<p_dist->nb_coord;icoord++,coord++)
	{   atom0 =atom_ptr(coord->at0);
	    atom1 = atom_ptr((coord->endat)->at);
	    sym_coef = coord->endat->coef;
	    d = dist_atom( atom0, atom1, sym_coef, u, gu);
	    tot += sqr ( e=((d - d0) / s0));
	    if (fini && minli==0) fprintf (list_fich,
		" %3d : %6s -> %6s : d=%6.3f dd/s=%5.2f  (%5.2f %5.2f %5.2f)\n",
		icoord,atom0->nom,atom1->nom,d,e,u[0],u[1],u[2]);
	    else if ( minli <= 0 )
	    {   for (j=0;j<3;j++)
		{   jj = 3*j;
		    sgu[j] = sym_coef[jj] * gu[0] + sym_coef[jj+1] * gu[1] 
		    	+ sym_coef[jj+2] * gu[2];
		    }
		d_size = nb_atom_param (atom0) + nb_atom_param (atom1);
		var_init(p_dist->dist);
		VAR_io_id  if (var_param(0)!=0) d_size++;
		if (d_size)
		{   l_deriv = deriv = 
		      (float *) tst_alloc (d_size,sizeof(float),"deriv_dist");
		    jderiv = ideriv =
		       (int *) tst_alloc (d_size,sizeof(int),"deriv_dist");

		var_init(atom0->x);
		VAR_io_id for (jj=0;jj<3;jj++) 
			if ((j=var_param(jj))!=0)
			{   *l_deriv++ = gu[jj] * var_derive()/d/s0;
				*jderiv++ = j-1 ;
				}
		var_init(atom1->x);
		VAR_io_id for (jj=0;jj<3;jj++) 
			if ((j=var_param(jj))!=0)
			{   *l_deriv++ = -sgu[jj] * var_derive()/d/s0;
				*jderiv++ = j-1;
				}
		var_init(p_dist->dist);
		VAR_io_id  if ((j=var_param(0))!=0)
			{   *l_deriv++  =  var_derive()/s0;
				*jderiv++ = j-1;
				}
						
			for (j=0;j<d_size;j++) 
			{	jj = ideriv[j];	
				jd = (jj*(jj+1))/2;
		 	      	 y_vect[jj] += e * deriv[j];
		 	      	 for (i=0;i<d_size;i++)
		 	      	 if ((ii=ideriv[i]) <= jj)  matrice[jd+ii] += deriv[j] * deriv[i];
				}
			free (deriv);
			free (ideriv);
		  }    }
	     }
	if (fini && minli==0) fprintf (list_fich,"\n");
	}
    return (tot);
    }

/* --------------------------------------------------------------------------- */
static float tot_pena_angl(P_(void))
{   int idist,icoord;
    int i,j,ii,jj,ji,jd;
    TYPE_PENAL  *p_dist;
    TYPE_COORD *coord;
    float tot=0;
    float u[2][3],gu[2][3],guu[3],sgu[3];
    float *sym_coef[2];
    float da,d[2],e,d0,s0;
    float db,dc,dd;
    TYPE_ATOM  *atom0, *atom[2];
    float *deriv, *l_deriv;
    int   d_size, *ideriv, *jderiv;

    p_dist = l_phase->angl;
    for (idist=0;idist<l_phase->nb_angl;idist++,p_dist++)
    {   var_init(p_dist->dist);
	d0 = var_valeur (0);
	s0 = p_dist->sigma;
	coord = p_dist->coord;
	for (icoord=0;icoord<p_dist->nb_coord;icoord++,coord++)
	{   atom0 =atom_ptr(coord->at0);
	    for (j=0;j<2;j++)
	    {  atom[j] = atom_ptr(coord->endat[j].at);
	       sym_coef[j] = coord->endat[j].coef;
			 d[j] = dist_atom (atom0, atom[j], sym_coef[j], u[j], gu[j]);
	       }
	    db = scalaire (u[1],guu,u[0]);
	    dc = db/(d[0]*d[1]);
	    da = acos (dc)/RAD;
	    dd = -1/ sqrt (1 - dc*dc) / RAD;
	    tot += sqr ( e=((da - d0) / s0));
	    if (fini && minli==0) fprintf (list_fich,
   " %3d : (%6s -> %6s :%4.1f)  (%6s -> %6s :%4.1f): a=%6.3f da/s=%5.2f\n",
		icoord, atom0->nom, atom[0]->nom, d[0],
                atom0->nom, atom[1]->nom, d[1], da, e);
	    else  if ( minli <= 0 )
	    {   d_size = nb_atom_param(atom0) + nb_atom_param(atom[0]) 
		       + nb_atom_param(atom[1]);
		var_init(p_dist->dist);
		VAR_io_id  if (var_param(0)!=0) d_size++;
		if (d_size)
		{   l_deriv = deriv = 
		      (float *) tst_alloc (d_size,sizeof(float),"deriv_angl");
		    jderiv = ideriv = 
		       (int *) tst_alloc (d_size,sizeof(int),"deriv_angl");

		var_init(atom0->x);
		VAR_io_id for (jj=0;jj<3;jj++) 
		if ((j=var_param(jj))!=0)
		{   *l_deriv++ = - var_derive() * dd /(s0 * d[0] *d [1])
			      *( gu[0][jj] + gu[1][jj] + db * 
			         ( gu[0][jj] * d[1] + gu[1][jj] * d[0]));
				*jderiv++ = j-1 ;
				}

		for (ji=0; ji<2; ji++)
                {   for (j=0;j<3;j++)
		    {   jj = 3*j;
		        sgu[j] = sym_coef[ji][jj] * gu[ji][0] 
                               + sym_coef[ji][jj+1] * gu[ji][1] 
                               + sym_coef[ji][jj+2] * gu[ji][2];
		        }
		    var_init(atom[ji]->x);
		    VAR_io_id for (jj=0;jj<3;jj++) 
		    if ((j=var_param(jj))!=0)
		     {   *l_deriv++ =  var_derive() * dd /(s0 * d[0] *d [1])
			      *( sgu[jj] + sgu[jj] + db *
			       ( sgu[jj] * d[1] + sgu[jj] * d[0]));
				*jderiv++ = j-1;
				}
                         }
		var_init(p_dist->dist);
		VAR_io_id  if ((j=var_param(0))!=0)
		{   *l_deriv++  =  var_derive()/s0;
			*jderiv++ = j-1;
			}

		for (j=0;j<d_size;j++) 
		{	jj = ideriv[j];	
			jd = (jj*(jj+1))/2;
		       	 y_vect[jj] += e * deriv[j];
		       	 for (i=0;i<d_size;i++)
		       	 if ((ii=ideriv[i]) <= jj) 
		   	 matrice[jd+ii] += deriv[j] * deriv[i];
			}
			free (deriv);
			free (ideriv);
		  }    }
	     }
	if (fini && minli==0) fprintf (list_fich,"\n");
	}
    return (tot);
    }
/* --------------------------------------------------------------------------- */
float penal(P_(void))
{    int i;
    float *p_bond;
    float tot=0;
    push_err_msg("penality");
    current_symgrp = l_phase->symgrp;
    l_atom = l_phase->atom;
    p_bond = l_phase->bond;
   if (fini && minli==0) fprintf (list_fich,"\n PENALITES\n");
   for (i=0;i<l_phase->nb_bond;i++,p_bond++)
	{   if (fini && minli==0 && n_phase>1) 
                  fprintf (list_fich," PHASE '%s' a %f\n",l_phase->nom,*p_bond);
		temp_phase = *p_bond-l_phase->temp_orig;
		temp = &temp_phase;
		if ( ini_metric () != 0)
		{   if (l_phase->nb_bloc) ini_blk(0);
		    if (l_phase->nb_dist) tot += tot_pena_dist ();
		    if (l_phase->nb_angl)
		    {   tot += tot_pena_angl ();
		        }
		    if (l_phase->nb_bloc) free_blk();
		    }
	  if (fini && minli==0) fflush(list_fich);
	  }
    pop_err_msg();
    return (tot);
    }
/* --------------------------------------------------------------------------- */
