static char *cvs_id =" $Id: xnd_rad.c,v 1.4 2002/09/13 14:52:55 berar Exp $ ";
/* XND_RAD    simple radial distribution ...          */
/* simple model according D Simeone @saclay.cea.fr    */
/* using formulae 11-15 from  Klug and Alexander      */
/* I/N = Sigma(m) f(m)^2 + 4 pi  fe^2 Sum(0,inf)      */
/*     Sigma(m) K(m) deltaG(m,r)   r^2  sin(sr)/sr dr */
/* with N = scale                                     */
/* modified into                                      */
/* I/N = Sigma(m)[f(m,s)^2 ( 1 + 4 pi / f(m,0)        */
/*            Sum(0,inf) dG(m,r) r^2 sin(sr)/sr dr )] */
/* .................................................. */
#define  USE_BRAGG
#define  USE_VAR
#define  USE_SCAN
#define  USE_EXPER
#define  USE_PHASE
#define  USE_ATOM
#include "../xnd_def.h"
#include "../xnd_cah.h"
#include "../xnd_mem.h"
/* ---------------------------------------------------------- */
void int_radist (P_(void))
{  float *coef, *d_coef, *z_coef, *zo_coef, *a_coef, *dist;
	int   n, ip, ia, ic;
	int   nd, nv, iod, i, j;
   int   calc_deriv;
	int   iprint=100;
   
   if (minli==0) fprintf(list_fich,"\n");
   if (n_pts > 10*iprint ) iprint *= 1+n_pts/(10*iprint);
   if ( l_phase->nb_dist > 0)
   {  nd = l_phase->nb_dist;
      nv = nd;
      }
   else 
   {  nd = -l_phase->nb_dist;
      nv = -nd*l_phase->n_atom;
      } 
	z_coef = (float *) tst_alloc (l_phase->n_atom, sizeof(float),"distrib");
	zo_coef = (float *) tst_alloc (l_phase->n_atom, sizeof(float),"distrib");
	a_coef = (float *) tst_alloc (l_phase->n_atom, sizeof(float),"distrib");
   s=EPSILON;
   for (ia=0,l_atom=l_phase->atom;ia<l_phase->n_atom;ia++,l_atom++)
   {  float f;
      f = (*valdif)();
      if (dif_nature == EXPER_RXA) 
      {   f+=anodif();
          zo_coef[ia] = sqrt(sqr(f) + sqr(anodif_b()));
          }
      else  zo_coef[ia] = f;
      }
	coef = (float *) tst_alloc (nv, sizeof(float),"distrib");
   temp = &temp_phase;
   var_init(l_phase->radial);
	for (ic=0; ic<nv;ic++) coef[ic]=var_valeur(ic);
   d_coef = (float *) tst_alloc (nv, sizeof(float),"distrib");
   dist = (float *) l_phase->radial->link;
   for (act->lambda=0;act->lambda<l_exper->n_lambda;act->lambda++)
	{  temp = &temp_exper;
	   var_init (l_onde);
		lambda = var_valeur (act->lambda*LAMBDA);
		exper_echelle = var_valeur (act->lambda*LAMBDA+1);
		echelle = phase_echelle * exper_echelle;
      temp = &temp_phase;
      for (ip=0,l_points=l_diag->points;ip<n_pts;ip++,l_points++)
      {  float qq, ampli, ycal, fsum;
         sin_t = sin (0.5*RAD**l_points);   /* valcor */
         qq = 2 * M_PI * (s = 2 * sin_t / lambda);
         cos_t = sqrt (1-sin_t*sin_t);
         valcor ();
         fsum = 0;
         for (ia=0,l_atom=l_phase->atom;ia<l_phase->n_atom;ia++,l_atom++)
         {  float occ, f;
            int nb = l_atom->nb;
            var_init(l_atom->x);
            occ = var_valeur (0);
            f = (*valdif)();
            if (dif_nature == EXPER_RXA) 
            {   f+=anodif();
                z_coef[ia] = occ * (sqr(f) + sqr(anodif_b()));
                }
            else  z_coef[ia] = occ * sqr(f);
            fsum += z_coef[ia];
            a_coef[ia]=0;
            }
			for (n=0;n<nv;n++)
			{  int in = n/nd;
            int jn = n%nd;
            float dr;
            float bqq = qq*dist[n];
            if (jn == 0)  dr = dist[n+1]-dist[n];
            else if (jn == nd-1)  dr = dist[n]-dist[n-1];
            else           dr = 0.5*(dist[n+1]-dist[n-1]);
				d_coef[n] = (qq > EPSILON) ? (4 * M_PI) * dist[n] * dr * sin(bqq)/qq : 0;
            a_coef[in] += coef[n] * d_coef[n]; 
				}  
			if ( nv == nd)
            ycal= echelle * fsum * ( 1 + a_coef[0]/zo_coef[0] ) * act->cor; 
         else
         {   ycal = 0;
             for (ia=0;ia<l_phase->n_atom;ia++)
                ycal += echelle * z_coef[ia] * ( 1 + a_coef[ia]/zo_coef[ia] ) * act->cor; 
             }   
			add_ical(ip, ycal); 
         if ( minli== 0 && ip % iprint == 0 )  fprintf(list_fich , 
              "radial_dist : %4d  (tth=%7.3f q=%7.2f) ->  %8g\n",ip, *l_points, qq, ycal);     
         if (do_derivatives)
			{  if (var_ideriv(l_onde)) 
			   { 	 temp = &temp_exper;
		          VAR_io_id
		          i=act->lambda*LAMBDA+1;
		          if ((j=var_param(i))!=0)
		            add_dydp(ip, j, ycal / exper_echelle * var_derive());
		          temp = &temp_phase;
					 }
            if (var_ideriv(l_phase->ech)) 
			   { 	VAR_io_id  
                 if ((j=var_param(0))!=0)
		            add_dydp (ip, j, ycal * *(d_echelle) * var_derive());
               }
            if (var_ideriv(l_phase->transit)) 
		      {  VAR_io_id  for (i=0;i<var_number;i++)
		           if ((j=var_param(i))!=0)
		             add_dydp(ip, j,ycal * var_derive()* *(d_echelle+l_phase->ech->number+i));
					}
			   if ( nv == nd)
				{   if (var_ideriv(l_phase->radial))
	             {   VAR_io_id  for (i=0;i<nv;i++)
	                 if ((j=var_param(i))!=0)
	                    add_dydp(ip, j, d_coef[i]/zo_coef[0]  * fsum * echelle * act->cor * var_derive());
	              }  }
            else
				{   if (var_ideriv(l_phase->radial))
	             {   VAR_io_id  for (i=0;i<nv;i++)
	                 if ((j=var_param(i))!=0)
	                    add_dydp(ip, j, d_coef[i]/zo_coef[i%nd]  * z_coef[i%nd] * echelle * act->cor * var_derive());
	              }  }
		      } 
      else if ( do_plg_data )
      {  add_ipha(ip, act->phase, ycal);
         }
	   }   /* nv loop */ 
   }  /* ip loop */
   free(coef);
   free(d_coef);
   free(z_coef);
   free(zo_coef);
   free(a_coef);
	}
/* ---------------------------------------------------------- */
