static char *cvs_id =" $Id: xnd_inc.c,v 1.2 2002/01/10 15:24:42 berar Exp $ ";
/* XND_INC.C   procedures for incommensurate modulated phases    */
/*             structure factor, initialisation                  */
/*        --------------------------------                       */                                     
/* in collaboration with Dominique Grebille and Guido Baldinozzi */
/* when written in 91-92, then in Dec 95, in Jan 97              */
/* then changed to agree with Big Indices (the super cell ones)  */
/*        --------------------------------                       */                                     
 
#define  USE_BRAGG
#define USE_VAR
#define USE_MODUL
#define USE_SYM
#define USE_SETS
#define USE_ATOM
#define USE_PHASE
#define USE_PSEUDO
#include "../xnd_def.h"
#include "../xnd_cah.h"
#include "xnd_moh.h"

#include <string.h>
#include <ctype.h>
/* ---------------------------------------------------------- */
/* tables used in fhkl_atom functions */
static float  *x_modul=NULL; 
static double *s_modul=NULL; 
static double *c_modul=NULL; 
static double *as_modul=NULL; 
static double *ac_modul=NULL; 
static double *bs_modul=NULL; 
static double *bc_modul=NULL; 
static double *as_tmodul=NULL; 
static double *ac_tmodul=NULL; 
static double *bs_tmodul=NULL; 
static double *bc_tmodul=NULL; 
/* ---------------------------------------------------------- */
/* ---------------------------------------------------------- */
/* procedure for calculation of structure factor for          */
/* incomensurate modulated phases including composites        */
/*    pos contient la position de depart dans le tableau des  */
/*         derivees des coordonnees atomiques                 */
/*    mul                                                     */
/*    return : nombre de parametres atomiques                 */
/*    les  valeurs de F_A, F_B sont modifiees                 */    
/* ---------------------------------------------------------- */
int  fhkl_incmod (P_(int) pos)
#ifdef NO_PROTO
int pos;
#endif
{
   int    ii, jj, o;
   int    i, j, ic, nb, pos_mod;
   int    isym, iatom, hklm[4];
   int    step, nb_step;
   float  step_width;
   float  f, fm, fbm;
   float  x_coord[3], h_sym[3], h_phi[3];
   float  bb[6], hk_sym[6];
   float  *l_coef;
   double trans, phi4, sym4;
   float  h_mod[3], hs_mod[3];
   double phi,c_phi,s_phi,debye;
   float  t_coord, t_eff;
   double t, m_sat, gamma;
   double phase, c_p, s_p;
   double a_mod, b_mod, a_tmod, b_tmod, phi_mod;
   double c_a, s_a, c_b, s_b, d_a, d_b;
   TYPE_SYMGRP *l_sym, *l_sym4;
   double a = 0;
   double b = 0;
   int omax = l_atom->n_modul;
   int nb_mod = AMODUL * omax;

   pos_mod = pos + l_atom->nb;
   nb = l_atom->nb + nb_mod;
   if (deriv_atom)   for (j=0;j<nb;j++)
   {  fab_deriv[0][pos+j] = 0;
	   if (!centro) fab_deriv[1][pos+j] = 0;
	   }
   iatom = l_atom - l_phase->atom;
   hklm[0]=H;
   hklm[1]=K;
   if (current_modul->compo_atom && iatom >= current_modul->compo_atom) 
   {  l_sym = l_phase->modul->compo_sym;
      l_sym4 = l_phase->modul->compo_sym4;
      hklm[3]=L;
      hklm[2]=act->h[3];
      var_init(l_phase->vector);
      for (i=0; i<3; i++) if ((gamma = var_valeur(i))) h_mod[i]=hklm[3]/gamma; else h_mod[i]=0;
	   gamma = var_valeur(2);
	   }
   else	
   {  l_sym = l_phase->symgrp;
      l_sym4 = l_phase->modul->symgrp;
      hklm[2]=L;
      hklm[3]=act->h[3];
      var_init(l_phase->vector);
      for (i=0; i<3; i++) h_mod[i] = hklm[3] * var_valeur(i);
      gamma = 1;
      if (l_atom->n_modul==0)
      {  if (hklm[3] == 0) return fhkl_atom(pos);
         else return nb;
         }
      }
   m_sat = hklm[3];

   nb_step = -current_modul->order;
   var_init (l_atom->x);
   for (i=0; i<3; i++) x_coord[i] = var_valeur(i);
   t_coord = var_valeur(3);
   if ((l_atom->nature & B_ANISO) == 0)
   {  debye = debye_0( var_valeur (4) );
      }
   else for (i=0;i<6;i++) bb[i] = var_valeur (i+4);

   if (l_atom->n_modul != 0)
   {  var_init(l_atom->modul);
      for (i=0;i<nb_mod;i++) x_modul[i] = var_valeur (i);
      }

   for (isym=0, l_coef=l_sym->coef; isym<l_sym->nops; isym++, l_coef+=12)
   {  for (i=0; i<3; i++)
         h_sym[i] = l_coef[3*i] * hklm[0] + l_coef[3*i+1] * hklm[1] + l_coef[3*i+2] * hklm[2];
	   trans = hklm[0] * l_coef[9] + hklm[1] * l_coef[10] + hklm[2] * l_coef[11];
      for (i=0; i<3; i++)
         hs_mod[i] = h_sym[i] +l_coef[3*i] * h_mod[0]
                    + l_coef[3*i+1] * h_mod[1] + l_coef[3*i+2] * h_mod[2];

      /* operation de symetrie sur les phases de la modulation */
      /* sym4=epsilon; phi4=tau; m_sat est m (ou bien k_4) */
	   sym4 = (l_sym4)->coef[2*isym];
      phi4 = (l_sym4)->coef[2*isym+1];
      /* les termes en phi4 viennent d'un changement de variable dans integr */
      phi =  trans + m_sat * phi4;
      for (i=0; i<3; i++) phi += ( h_phi[i] = hs_mod[i] - sym4 * h_mod[i] ) * x_coord[i] ;
	   phi *= M_2PI;
      if (l_atom->nature & B_ANISO) debye = debye_2( bb, h_sym, hk_sym);
      /* for one atom f = e(i H X) integ(  n(t) e(i H x(t)) ) */
	   c_phi = debye * cos(phi);
	   s_phi = debye * sin(phi);
	   /* now, integrating over the modulation */
      /* integr(0,1) exp(2pi.i(hm.x_sin.sin(2pi.o.t)+hm.x_cos.cos(2pi.o.t)+km ...))  */
      /* le changement de variable sur t impose le signe de step_width mais rattrape par bornes */
      step_width = 1.0/nb_step;
      a_mod = b_mod = a_tmod = b_tmod = 0;
      if ( deriv_atom) for (o=0; o<omax; o++, jj++)
             as_modul[o] = ac_modul[o] = bs_modul[o] = bc_modul[o] =
             as_tmodul[o] = ac_tmodul[o] = bs_tmodul[o] = bc_tmodul[o] = 0;
        for (step=0, t=0; step< nb_step; step++, t+=step_width )
        {    phi_mod  = sym4 * m_sat * t;
             t_eff = t_coord;
             for (o=0; o<omax; o++)  {
                   phase = M_2PI*(o+1)*t;
                   s_modul[o]=sin(phase);
                   c_modul[o]=cos(phase);
                   }
             for (o=0; o<omax; o++)
             {    for ( i=0,ii=o*AMODUL; i<3; i++, ii+=2)
                  {   phi_mod += hs_mod[i] * ( x_modul[ii] * s_modul[o]
                             + x_modul[ii+1] * c_modul[o] );
                      }
                  t_eff  += x_modul[ii] * s_modul[o] + x_modul[ii+1] * c_modul[o];
                  }
             a_mod += c_p = step_width * cos(M_2PI * phi_mod);
             b_mod += s_p = step_width * sin(M_2PI * phi_mod);
             a_tmod += t_eff * c_p;
             b_tmod += t_eff * s_p;
   
             if (deriv_atom)
             {    for (o=0; o<omax; o++)
                  {    as_modul[o] += c_p * s_modul[o];
                       ac_modul[o] += c_p * c_modul[o];
                       bs_modul[o] += s_p * s_modul[o];
                       bc_modul[o] += s_p * c_modul[o];
                       as_tmodul[o] -= M_2PI * t_eff * s_p * s_modul[o];
                       ac_tmodul[o] -= M_2PI * t_eff * s_p * c_modul[o];
                       bs_tmodul[o] += M_2PI * t_eff * c_p * s_modul[o];
                       bc_tmodul[o] += M_2PI * t_eff * c_p * c_modul[o];
                       }
                  } /* deriv_atom */
             } /* for step */
       /* le facteur de structure global*/
        s_a = s_phi * a_tmod;
        c_b = c_phi * b_tmod;
        a += c_a = c_phi * a_tmod;
        a -= s_b = s_phi * b_tmod;
        if (!centro)   b += s_a + c_b;
        if (deriv_atom)
	{    d_a = - M_2PI * (s_a + c_b);
             for (i=0; i<3; i++)   fab_deriv[0] [pos+i] += h_phi[i] * d_a;
	     fab_deriv[0] [pos+3]   += c_phi * a_mod - s_phi * b_mod;
	     if (l_atom->nature & B_ANISO)
	     {     d_a = - (s_a + c_b);
                   for (i=0; i<6; i++)  fab_deriv[0] [pos+4+i] += hk_sym[i] * d_a;
                   }
             for (ii=o=0; o<omax; o++, ii+=2)
             {     for ( i=0; i<3; i++, ii+=2)
                   {    fab_deriv[0] [pos_mod+ii] += h_sym[i] * ( c_phi * as_tmodul[o] - s_phi * bs_tmodul[o])/gamma;
                        fab_deriv[0] [pos_mod+ii+1] += h_sym[i] * ( c_phi * ac_tmodul[o] - s_phi * bc_tmodul[o])/gamma;
                        }
                   fab_deriv[0] [pos_mod+ii]   += (c_phi * as_modul[o] - s_phi * bs_modul[o])/gamma;
                   fab_deriv[0] [pos_mod+ii+1] += (c_phi * ac_modul[o] - s_phi * bc_modul[o])/gamma;
                   }
             if (!centro)
             {    d_b = - M_2PI * (s_b - c_a);
                  for (i=0; i<3; i++)   fab_deriv[1] [pos+i]   += h_phi[i] * d_b;
                  fab_deriv[1] [pos+3] += s_phi *a_mod - c_phi *b_mod;
	          if (l_atom->nature & B_ANISO)
	          {    d_b = - (s_b - c_a);
                       for (i=0; i<6; i++) fab_deriv[1] [pos+4+i] += hk_sym[i] * d_b;
                       }
                  for (o=0; o<omax; o++)
                  {    for ( i=0,ii=o*AMODUL; i<3; i++, ii+=2)
                       {    fab_deriv[1] [pos_mod+ii+1] +=  h_sym[i] * (s_phi * as_tmodul[o] + c_phi * bs_tmodul[o])/gamma;
                            fab_deriv[1] [pos_mod+ii+1] +=  h_sym[i] * (s_phi * ac_tmodul[o] + c_phi * bc_tmodul[o])/gamma;
                            }
                       fab_deriv[1] [pos_mod+ii]   += (s_phi * as_modul[o] + c_phi * bs_modul[o])/gamma;
                       fab_deriv[1] [pos_mod+ii+1] += (s_phi * ac_modul[o] + c_phi * bc_modul[o])/gamma;
                       }
                  }  /*! centro */
           }
	} /* for isym */

    f = (*valdif)();
    /* si diffusion anomale on traite a part la contrib imaginaire de f */
    if (dif_nature == EXPER_RXA)  f += anodif();
    fm = gamma * f * fhkl_mult;
    F_A += fm * a;
    if (!centro)  F_B += fm * b;

    if (dif_nature == EXPER_RXA)
    {    fbm = fhkl_mult * anodif_b();
	 act->f_abm[0] += fbm * a ;
	 if (!centro)  act->f_abm[1] += fbm * b;
	 }

    if (deriv_atom==0) return (0);

    if ((l_atom->nature & B_ANISO)==0) fab_deriv[0][pos+4] = -0.25 * q * a * gamma;
    for (j=0;j<nb;j++)  fab_deriv[0][pos+j] *= fm;
    if (dif_nature == EXPER_RXA)
	 for (j=0;j<nb;j++)  fabm_deriv[0][pos+j] = fab_deriv[0][pos+j] * fbm/fm;
    if (centro) return (nb);

    if ((l_atom->nature & B_ANISO)==0) fab_deriv[1][pos+4] = -0.25 * q * b * gamma;
    for (j=0;j<nb;j++)  fab_deriv[1][pos+j] *= fm;
     if (dif_nature == EXPER_RXA)
	 for (j=0;j<nb;j++)  fabm_deriv[1][pos+j] = fab_deriv[1][pos+j] * fbm/fm;
    return (nb);
    }
 /* ---------------------------------------------------------- */
 /* ---------------------------------------------------------- */
void alloc_incmod PROTO((void))
{  int i, j, nb_mod, omax = 0;
    fflush (list_fich);
    for (i=0,l_atom=l_phase->atom;i<l_phase->n_atom;i++,l_atom++)
      if (l_atom->n_modul > omax) omax =l_atom->n_modul;
    for (j=0;j<l_phase->nb_bloc;j++)
      for (i=0,l_atom=l_phase->bl_relat[j];i<l_phase->bl_atom[j];i++,l_atom++)
         if (l_atom->n_modul > omax) omax =l_atom->n_modul;
   if (omax != 0)
   {  x_modul = (float *) tst_alloc( AMODUL * omax, sizeof(float),"fhkl_incmod");
      s_modul = (double *) tst_alloc( omax, sizeof(double),"fhkl_incmod");
      c_modul = (double *) tst_alloc( omax, sizeof(double),"fhkl_incmod");
      if (deriv_atom)
		{  as_modul = (double *) tst_alloc( omax, sizeof(double),"fhkl_incmod");
         ac_modul = (double *) tst_alloc( omax, sizeof(double),"fhkl_incmod");
         bs_modul = (double *) tst_alloc( omax, sizeof(double),"fhkl_incmod");
         bc_modul = (double *) tst_alloc( omax, sizeof(double),"fhkl_incmod");
         as_tmodul = (double *) tst_alloc( omax, sizeof(double),"fhkl_incmod");
         ac_tmodul = (double *) tst_alloc( omax, sizeof(double),"fhkl_incmod");
         bs_tmodul = (double *) tst_alloc( omax, sizeof(double),"fhkl_incmod");
         bc_tmodul = (double *) tst_alloc( omax, sizeof(double),"fhkl_incmod");
         }
		}	
  }
 /* ---------------------------------------------------------- */
void free_incmod PROTO((void))
{  
   if (x_modul) { free(x_modul); x_modul=NULL; }
   if (s_modul) { free(s_modul); s_modul=NULL; }
   if (c_modul) { free(c_modul); c_modul=NULL; }
   if (as_modul) { free(as_modul); as_modul=NULL; }
   if (ac_modul) { free(ac_modul); ac_modul=NULL; }
   if (bs_modul) { free(bs_modul); bs_modul=NULL; }
   if (bc_modul) { free(bc_modul); bc_modul=NULL; }
   if (as_tmodul) { free(as_tmodul); as_tmodul=NULL; }
   if (ac_tmodul) { free(ac_tmodul); ac_tmodul=NULL; }
   if (bs_tmodul) { free(bs_tmodul); bs_tmodul=NULL; }
   if (bc_tmodul) { free(bc_tmodul); bc_tmodul=NULL; }
  }	  

 /* ---------------------------------------------------------- */
static int ini_inc_loop(P_(TYPE_PSEUDO *) l_pseudo_phase);
 /* ---------------------------------------------------------- */
 /* the following function is the initialisation procedure     */
int ini_pseudo_inc(P_(TYPE_PSEUDO *) l_pseudo_phase)
 {  int err;
    push_err_msg("ini_pseudo_inc(xnd_inc.c)");
    l_pseudo_phase->hkl_eff = hkl_modul;
    l_pseudo_phase->modul = current_modul = l_phase->modul;
    if ( current_modul->size > prt_modsize )
       prt_modsize = current_modul->size;
    l_pseudo_phase->genget_hkl = genget_mod;
/* modif  a verifier */
    if (l_phase->vector )
    {   l_pseudo_phase->fhkl_eff = fhkl_incmod;
        } else
    {   l_pseudo_phase->fhkl_eff = fhkl_commod;
        tst_abort(( current_modul->compo_atom != 0),
           "Commensurable composite are not supported");
           }
    err = ini_4D_extinction(l_pseudo_phase);
    if ( current_modul->compo_atom == 0)
    {  if (l_pseudo_phase->sets->nb_hkl<=0) err += ini_inc_loop(l_pseudo_phase);
		 else if (l_pseudo_phase->sets->loop_str == NULL || *l_pseudo_phase->sets->loop_str==0 )
       fprintf(list_fich," @SET::LINES=%d>0 skiping @SET::LOOP='%s'\n",
         l_pseudo_phase->sets->nb_hkl, l_pseudo_phase->sets->loop_str); 
			}
   else err += ini_composite(l_pseudo_phase);
   /* multiplicity rules are identical for fundamental and sat lines, nothing todo */
   pop_err_msg();
   return err;
   }
/* ---------------------------------------------------------- */
static int loop_label( short m, TYPE_PSEUDO * l_pseudo_phase)
{   char label[10];
    sprintf(label,"HKL,M=%d", m);
    l_pseudo_phase->sets->loop_str= (char *) str_alloc(label);
    l_pseudo_phase->satel=(TYPE_SATEL *) tst_alloc(1,sizeof(TYPE_SATEL),"sattelite");
    l_pseudo_phase->satel->n_ind=1;
    l_pseudo_phase->satel->hkl_sat[0]=m;
    fprintf(list_fich," 1 sattelite with M=%d according @SET::LOOP='%s'\n",
      m, l_pseudo_phase->sets->loop_str);
    return 0;
    }
static int error_label( TYPE_PSEUDO * l_pseudo_phase, char *msg)
{   verbose_printf("error : %s\n invalid string for incommensutare in @SET::LOOP='%s'\n",
      msg, l_pseudo_phase->sets->loop_str);
    return 1;
    }
/* ---------------------------------------------------------- */
static int ini_inc_loop(P_(TYPE_PSEUDO *) l_pseudo_phase)
{  TYPE_SATEL * l_satel;
   char *loop_str, *c, *e;
   char copy[50];
   int i, n;
   short m[21];
   loop_str = l_pseudo_phase->sets->loop_str;
   if (loop_str == NULL || *loop_str==0 )
   {  verbose_printf ("No @SET(LOOP) or empty one, assuming base line 'HKL,M=0'\n");
      if (loop_str) free(loop_str);
      return loop_label( 0, l_pseudo_phase);
      }
   c = strcpy(copy, loop_str);
   while ( *c==' '||*c==','||*c=='H'||*c=='K' ||*c=='L') c++;
   if (isdigit(*c) || *c=='-' )
   {  sscanf(c, "%hd", &m[0]);
      if (loop_str) free(loop_str);
      return loop_label( m[0], l_pseudo_phase);
      }
   if (*c++ != 'M') return error_label( l_pseudo_phase, "M expected" );
   while ( *c==' ' ) c++;
   if (*c++ != '=') return error_label( l_pseudo_phase, " = expected" );
   n = 0;
   e = strtok(c, ",");
   while ( e && *e != 0 )
	{  if (sscanf(e," %hd",m+n) != 1 ) return error_label(l_pseudo_phase, "HKLM= num expected"  );
      n++;
	   e = strtok(NULL, ",");
      if ( n>=21) return error_label(l_pseudo_phase, "HKLM=i,j... too much values in one set"  );
		}
   if (n==0) return error_label( l_pseudo_phase, "HKLM= num expected");
   l_pseudo_phase->satel=l_satel=(TYPE_SATEL *)
     tst_alloc(1,sizeof(TYPE_SATEL)+(n-1)*sizeof(short),"sattelite");
    l_satel->n_ind=n;
     for (i=0;i<n;i++) l_satel->hkl_sat[i]=m[i];
     fprintf(list_fich," %d sattelite(s) ( ", n);
     for (i=0;i<n;i++) fprintf(list_fich," %d ", l_satel->hkl_sat[i]);
   	fprintf(list_fich," ) according @SET::LOOP='%s'\n", l_pseudo_phase->sets->loop_str);
      return 0;
	  }
/* ---------------------------------------------------------- */

