/* XND_cif.C       output of standard ??? CIF   */
static char *cvs_id =" $Id: xnd_cif.c,v 1.2 2002/01/10 15:24:42 berar Exp $ ";
/*  prt_cif         8 append mode                  */
/*  256  no map , 512 no angles, 1024 no distances */
#define USE_RPRO
#define USE_RBRG
#define USE_VAR
#define USE_SETS
#define USE_MODUL
#define USE_SYM
#define USE_ATOM
#define USE_PHASE
#define USE_DIFDAT
#include "../xnd_def.h"
#include "../xnd_cah.h"   /* scalaire */


#include <string.h>
#include <ctype.h>

/* ------------------------------------------------------------------ */
char *xnd_release PROTO((void));                 /* from xnd_rdh.h */
/* ------------------------------------------------------------------ */
typedef struct cif_info
{  int par, num;
   float val, sig;
	char  id[9];
	} CIF_INFO;
static CIF_INFO * cif_info;
static void cif_section(int i, char *cif_id);
static void cif_string(char *id, char *val);
static char *cif_ref_val(int i, char *xnd_id);
static CIF_INFO* cif_sigma(int i, char *xnd_id);
static char *cif_format  (float val, float sig, int d);
static void cif_search_bonds (FILE *map_fich);
static void cif_print_sym (void);
/* ------------------------------------------------------------------ */
void cif_out (TYPE_RPRO * indic, int nt_par, int npen)
{   int   i, j, n, i_phase, anis, modul, set_0=0;
    int *rd_inf=NULL;
    CIF_INFO *info, *inf;
	 TYPE_SETS *l_sets;
	 char  *e, *f, buffer[82];
	 float x, u[6], *rf_inf=NULL;
	 FILE *map_fich;
    push_err_msg("cif_out (xnd_cif.c)");
    if ( n_var )
	 {  cif_info = (CIF_INFO *) tst_alloc (n_var,sizeof(CIF_INFO),"cif_info");
		 verbose_printf("\n Generating %s file\n", cif_name);
	    cif_fich = tst_open (cif_name,"r","read CIF info file");
	    for (i=0; i<n_var && ! feof(cif_fich) ;i++)
	    {  buffer[0]=0;
          fgets(buffer, 80, cif_fich);
	       if ( buffer[0]=='#'|| buffer[0]==0)  { i--; continue; }
	       info = cif_info+i;
	       sscanf(buffer," %d %8s %d %f %f", &info->par, info->id, &info->num, &info->val, &info->sig);
		    }
	   if (tot_phase > 1 )
	   {  rf_inf = (float *) malloc(tot_phase * 3 * sizeof(float));
         rd_inf = (int *)   malloc(tot_phase * 3 * sizeof(int));
	 	   for (i=0,j=0; i<tot_phase;i++,j+=3)
	      {  fgets(buffer, 80, cif_fich);
	         if ( buffer[0]=='#')  { i--; j-=3; continue; }
	         rd_inf[j] = rd_inf[j+1] = rd_inf[j+2] = 0;
	         rf_inf[j] = rf_inf[j+1] = rf_inf[j+2] = 0;
		   	 sscanf(buffer," %d %f %d %f %f %d", rd_inf+j, rf_inf+j, 
			       rd_inf+j+1, rf_inf+j+1, rf_inf+j+2, rd_inf+j+2);
		     }
       } else { rd_inf = NULL; rf_inf = NULL; }
	   cif_fich = xclose (cif_fich);
	   }
    else 
	 {  cif_info = NULL;
		 verbose_printf("\n Generating %s file without standard deviation\n", cif_name);
	    }
	 if (prt_cif & 8) cif_fich = tst_open (cif_name,"a","real CIF file");
    else             cif_fich = tst_open (cif_name,"w","real CIF file");
	 strcpy(buffer,cif_name);
	 e = strstr (buffer, ".cif");
	 if (e) *e = 0;
	 strcat(buffer,".map");
	 if ((prt_cif & 256) == 0) map_fich = tst_open (buffer,"w","real CIF file");
	 else map_fich = NULL;
    fprintf(cif_fich,"#=================================================\n");
    fprintf(cif_fich,"# lines generated to be copied into a CIF\n");
    fprintf(cif_fich,"# procedure in test\n");
    fprintf(cif_fich,"# please, do not use with expended parameters\n");
    fprintf(cif_fich,"#=================================================\n");
/*   for (i=0,l_exper = exper;i<n_exper;(i++,l_exper++))
    {   if (minli==0 || minli==-1)
           fprintf(list_fich," EXPER : %s\n%s", l_exper->nom, entete);
    fput_var(l_exper->onde);
    fput_var(l_exper->back);
    fput_var(l_exper->reglage);
    fput_var(l_exper->instru);
    fput_var(l_exper->asym);
    }
*/ for (i_phase=0,l_phase = phase;i_phase<n_phase;i_phase++,l_phase++)
   {  char *cif_key[6] = { "_cell_length_a", "_cell_length_b", "_cell_length_c", 
		   "_cell_angle_alpha", "_cell_angle_beta", "_cell_angle_gamma" };
      if (l_phase->nb_atom == 0) continue;
      
		current_modul=l_phase->modul;
		fprintf(cif_fich,"#=================================================\n");
      fprintf(cif_fich,"data_'%s'\n", l_phase->nom);
      cif_section (5, "CHEMICAL DATA");
      cif_section (6, "POWDER SPECIMEN AND CRYSTAL DATA");
      if (current_modul && current_modul->compo_atom)		
		{  fprintf(cif_fich,"# Composite structure items\n");
		   fprintf(cif_fich,"_exptl_crystal_type_of_structure      'comp'\n");
		   fprintf(cif_fich,"_cell_subsystem_number                2\n");
		   fprintf(cif_fich,"_cell_modulation_dimension            1\n");
		   fprintf(cif_fich,"_cell_reciprocal_basis_vect_number    4\n");
		   fprintf(cif_fich,"loop_\n");
		   fprintf(cif_fich,"_cell_subsystem_code\n");
		   fprintf(cif_fich,"_cell_subsystem\n");
		   fprintf(cif_fich,"_cell_subsystem_matrix_W_1_1\n");
		   fprintf(cif_fich,"_cell_subsystem_matrix_W_2_2\n");
		   fprintf(cif_fich,"_cell_subsystem_matrix_W_3_3\n");
		   fprintf(cif_fich,"_cell_subsystem_matrix_W_3_4\n");
		   fprintf(cif_fich,"_cell_subsystem_matrix_W_4_3\n");
		   fprintf(cif_fich,"_cell_subsystem_matrix_W_4_4\n");
		   fprintf(cif_fich,"BASIS   '1-st subsystem'  1 1 1 0 0 0\n");
		   fprintf(cif_fich,"\n# following cell is associated with the BASIS subsystem\n\n");
		   }
		
      x = ini_metric();
		cif_print_sym();
		/*var_init(l_phase->cell);*/
      for (i=1; i<var_number; i++)
	   {  for (var_io=0;var_io<var_order;var_io++)
         {  for (var_id=0;var_id<var_dim;var_id++)
               fprintf(cif_fich,"%-20s  %s\n", cif_key[i-1],  cif_ref_val (i, T_CELL));
            }
			}	
	   fprintf(cif_fich,"%-20s   %8f\n", "_cell_volume", x);
      cif_section (7, "EXPERIMENTAL DATA");
      cif_string ("_computing_structure_refinement", xnd_release());
      cif_section (8, "REFINEMENT DATA");
      if ( n_exper > 1)
		   fprintf(cif_fich,"# xnd uses %d experiments, following values are related to the whole data\n", n_exper);
      if ( n_phase > 1)
		   fprintf(cif_fich,"# xnd uses %d phases, following values are related to the whole data\n", n_phase);
		
		fprintf(cif_fich,"_pd_proc_ls_profile_function  voigt\n");
		fprintf(cif_fich,"_pd_proc_ls_prof_wR_factor    %.3f\n", sqrt (indic->sd_wp/indic->so_wp));
		fprintf(cif_fich,"_pd_proc_ls_prof_R_factor     %.3f\n", indic->sd_p/indic->so_p);
		fprintf(cif_fich,"_pd_proc_ls_prof_wR_expected  %.3f\n", sqrt ((indic->s_n+n_pen-nt_par)/indic->so_wp));
		fprintf(cif_fich,"_refine_ls_goodness_of_fit    %.3f\n", sqrt(indic->sd_wp/(indic->s_n+n_pen- nt_par)));
		fprintf(cif_fich,"_pd_proc_number_of_points     %d\n", indic->s_n);
		fprintf(cif_fich,"_refine_ls_number_parameters  %d\n", nt_par);
		if (o_brg.io)
		fprintf(cif_fich,"_refine_ls_R_I_factor         %.3f\n", o_brg.di/o_brg.io);
		if (o_brg.fo)
		fprintf(cif_fich,"_refine_ls_R_F_factor         %.3f\n", o_brg.df/o_brg.fo);
		if (l_phase->nb_sets > 1)
		{	fprintf(cif_fich,"\n_diffrn_reflns_number_of_classes  %d\nloop_\n", l_phase->nb_sets);
         fprintf(cif_fich,"_diffrn_reflns_class_code\n_diffrn_reflns_class_description\n");
         l_sets=l_phase->sets;
			for (i=0; i<l_phase->nb_sets ; i++,l_sets++)
		   {  fprintf(cif_fich,"%s%d  ", "Set_", i);
            if (l_sets->loop_str && *l_sets->loop_str) fprintf(cif_fich," loop='%s'", l_sets->loop_str);
            if (l_sets->allow_str && *l_sets->allow_str) fprintf(cif_fich," allow='%s'", l_sets->allow_str);
            if (l_sets->deny_str && *l_sets->deny_str) fprintf(cif_fich," deny='%s'", l_sets->deny_str);
		      fprintf(cif_fich,"\n");
			   } 
			}	 
		if (n_phase != tot_phase || l_phase->nb_sets > 1)
		{	fprintf(cif_fich,"\n_diffrn_reflns_number_of_classes  %d\n", l_phase->nb_sets==0?1:l_phase->nb_sets);
		   fprintf(cif_fich,"loop_\n_refine_ls_class_code\n");
		   fprintf(cif_fich,"_refine_ls_class_R_I_factor\n");
		   fprintf(cif_fich,"_reflns_class_R_I_number_of reflns\n");
		   fprintf(cif_fich,"_reflns_class_sum_of_I\n");
		   fprintf(cif_fich,"_refine_ls_class_R_F_factor\n");
		   fprintf(cif_fich,"_reflns_class_R_F_number_of reflns\n");
         for (i=0,j=set_0; i<l_phase->nb_sets || i<1; i++,j+=3)
		   {  fprintf(cif_fich,"%s%d  ", "Set_", i);
            fprintf(cif_fich," %5.3f  %4d   %8.3g", rf_inf[j], rd_inf[j+1], rf_inf[j+1]);
            fprintf(cif_fich,"   %5.3f  %4d ", rf_inf[j+2], rd_inf[j+2]);
		      fprintf(cif_fich,"\n");
			   }  
			} 
		set_0+=l_phase->nb_sets>1 ? l_phase->nb_sets : 1;
			
      cif_section (9, "ATOMIC COORDINATES AND DISPLACEMENT PARAMETERS");

		fprintf(cif_fich,"loop_\n");
      fprintf(cif_fich,"_atom_site_label\n");
      if (current_modul && current_modul->compo_atom)
		  fprintf(cif_fich,"_atom_site_subsystem_code\n");
		fprintf(cif_fich,"_atom_site_fract_x\n");
      fprintf(cif_fich,"_atom_site_fract_y\n");
      fprintf(cif_fich,"_atom_site_fract_z\n");
      fprintf(cif_fich,"_atom_site_occupancy\n");
      fprintf(cif_fich,"_atom_site_thermal_displace_type\n");
      fprintf(cif_fich,"_atom_site_U_iso_or_equiv\n");
      if (current_modul) fprintf(cif_fich,"_atom_site_displace_modulation_flag\n");
      fprintf(cif_fich,"_atom_site_type_symbol\n");
		anis=modul=0;
		for (j=0,l_atom=l_phase->atom;j<l_phase->n_atom;j++,l_atom++)
      {   fprintf(cif_fich,"    %-6s ", l_atom->nom);
          if (current_modul && current_modul->compo_atom)
		       fprintf(cif_fich," %-6s ", j<current_modul->compo_atom ? "BASIS":"COMPO");
          var_init(l_atom->x);
	       for (i=0; i<4; i++)
	       for (var_io=0;var_io<var_order;var_io++)
          {  for (var_id=0;var_id<var_dim;var_id++)
		       fprintf(cif_fich," %12s", cif_ref_val(i, l_atom->nom));
             }
			  if ((l_atom->nature & B_ANISO) == 0)
			  {  for (var_io=0;var_io<var_order;var_io++)
              {  for (var_id=0;var_id<var_dim;var_id++)
		           fprintf(cif_fich," Uiso %-12s", cif_ref_val(4, l_atom->nom));
                 }
			     } else {
		        anis++;
				  fprintf(cif_fich," Uani   %6f  ", u_equiv(l_atom->x, NULL));
			     }
           if (l_phase->modul)
			  {   if (l_atom->n_modul==0) fprintf(cif_fich,"   no " );
			      else
					{  fprintf(cif_fich,"  yes " );
					   modul++;
					}  }
	        f = e = atom_dif(buffer);
			  while (isdigit(*f)) f++;
			  f++;
			  while (*f && isupper(*f)) { *f=tolower(*f); f++;}
			  fprintf(cif_fich," %s\n", e);
           }
		if (anis)
      {  fprintf(cif_fich,"loop_\n");
         fprintf(cif_fich,"_atom_site_aniso_label\n");
         fprintf(cif_fich,"_atom_site_aniso_U_11\n");
         fprintf(cif_fich,"_atom_site_aniso_U_22\n");
         fprintf(cif_fich,"_atom_site_aniso_U_33\n");
         fprintf(cif_fich,"_atom_site_aniso_U_12\n");
         fprintf(cif_fich,"_atom_site_aniso_U_13\n");
         fprintf(cif_fich,"_atom_site_aniso_U_23\n");
		   for (j=0,l_atom=l_phase->atom;j<l_phase->n_atom;j++,l_atom++)
         {  if ((l_atom->nature & B_ANISO) == 0) continue;
            fprintf(cif_fich,"    %-6s ", l_atom->nom);
            var_init(l_atom->x);
				u_equiv(l_atom->x, u);
	         for (i=4; i<10; i++)
	         for (var_io=0;var_io<var_order;var_io++)
            {  for (var_id=0;var_id<var_dim;var_id++)
		         if ((inf=cif_sigma(i, l_atom->nom))==NULL)
					    fprintf(cif_fich," %      #8f  ", u[i-4]);
					else   
					    fprintf(cif_fich," %-12s", cif_format(u[i-4], inf->sig*u[i-4]/inf->val,1));
               }
			    fprintf(cif_fich,"\n");
          }  }
		if (current_modul)
      {  fprintf(cif_fich,"\n# Modulation parameters\n");
         fprintf(cif_fich,"loop_\n");
         fprintf(cif_fich,"_cell_wave_vector_seq_id\n");
         fprintf(cif_fich,"_cell_wave_vector_x\n");
         fprintf(cif_fich,"_cell_wave_vector_y\n");
         fprintf(cif_fich,"_cell_wave_vector_z\n");
			var_init(l_phase->vector);
         fprintf(cif_fich,"1   ");
         for (i=0; i<var_number; i++)
	      {  for (var_io=0;var_io<var_order;var_io++)
            {  for (var_id=0;var_id<var_dim;var_id++)
		            fprintf(cif_fich," %12s",cif_ref_val(i, "VECTOR"));
               }
			   }	
         fprintf(cif_fich,"\nloop_\n");
         fprintf(cif_fich,"_atom_site_aniso_label\n");
         if (current_modul && current_modul->compo_atom)
		      fprintf(cif_fich,"_atom_site_subsystem_code\n");
         fprintf(cif_fich,"_atom_site_displace_Fourier_axis\n");
         fprintf(cif_fich,"_atom_site_displace_Fourier_wave_vector_seq_id\n");
         fprintf(cif_fich,"_atom_site_displace_Fourier_sin\n");
         fprintf(cif_fich,"_atom_site_displace_Fourier_cos\n");
		   for (j=0,l_atom=l_phase->atom;j<l_phase->n_atom;j++,l_atom++)
         {  int ie, imod, ixyz, ipar, iprint;
			   if ((l_atom->n_modul) == 0) continue;
	         ie = 5; if (l_atom->nature & B_ANISO ) ie = 10;
            var_init(l_atom->modul);
            for (ixyz=0; ixyz<3; ixyz++)
				for (imod=0; imod<l_atom->n_modul; imod++)
				{  iprint= 0;
				   ipar = 2 * ixyz + 8 * imod;
					for (i=0; i<2; i++)
			       for (var_io=0;var_io<var_order;var_io++)
                 for (var_id=0;var_id<var_dim;var_id++)
		             if ( cif_sigma(i + ipar, l_atom->nom) ) iprint++;
	            if (iprint)
					{  fprintf(cif_fich,"    %-6s", l_atom->nom);
					   if (current_modul && current_modul->compo_atom)
		               fprintf(cif_fich," %-6s", j<current_modul->compo_atom ? "BASIS":"COMPO");
                  fprintf(cif_fich," %c %d ", 'x'+ixyz, imod+1);
					   for (i=0; i<2; i++)
			         for (var_io=0;var_io<var_order;var_io++)
                   for (var_id=0;var_id<var_dim;var_id++)
		              fprintf(cif_fich," %12s",cif_ref_val(i + ipar, l_atom->nom));
			         fprintf(cif_fich,"\n");
                  } 
			    }   }
			 }
      cif_section (10, "MOLECULAR GEOMETRY");
      cif_string("_geom_special_details","?");
		   cif_search_bonds(map_fich);
     }
   cif_section (11, "POWDER PROFILE");
 	cif_fich = xclose(cif_fich);
   if (map_fich) close(map_fich);
	pop_err_msg();
   }
/* ------------------------------------------------------------------ */
static void cif_section(int i, char *cif_id)
{   fprintf(cif_fich,"#=================================================\n");
    fprintf(cif_fich,"# %d. %s\n",i , cif_id);
    }
/* ------------------------------------------------------------------ */
static void cif_string(char *id, char *val)
{   if (strchr(val, ' '))
	    fprintf(cif_fich,"%-20s  '%s'\n", id, val);
    else
	    fprintf(cif_fich,"%-20s  %s\n", id, val);
    }
/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */
static char* cif_ref_val(int i, char *xnd_id)
{  int j, n;
   CIF_INFO *info;
static char my_string[33];

   *my_string=0;
	if ((info=cif_sigma(i, xnd_id))==NULL)
	   sprintf(my_string,"% #5f", var_valeur(i));
	else 
      strcpy(my_string, cif_format(info->val, info->sig, 1));
	return my_string;
   }
/* ------------------------------------------------------------------ */
static CIF_INFO* cif_sigma(int i, char *xnd_id)
{  int j, n;
   CIF_INFO *info;
   if (cif_info == NULL) return NULL;
	if ((n=var_param(i))==0)  return NULL;
	for (j=0, info = cif_info; j < n_var; j++, info++)
	{  if (info->par != n) continue;
	   if (info->num != i) continue;
	   if (strcmp(info->id, xnd_id)) continue;
      return info;
		} 
	return NULL;
   }
/* ------------------------------------------------------------------ */
static char *cif_format  ( P_(float) val, P_(float) sig, P_(int) d)
#ifdef NO_PROTO
float a, b;
#endif
{
    int range;
    int ds;
static char buffer[40];
    push_err_msg("cif_format(xnd_cif.c)");
    range = -floor(log10(sig));
    if (range<=0)	      sprintf (buffer," % #.0f(% #.0f)", val, sig);
    else if (range>7)  sprintf (buffer," % #f(%f)", val, sig);
    else
	 {  ds=floor(sig*pow((double)10.0,(double) range)+0.5);
	    sprintf (buffer,"% #.*f(%d)", range, val, ds);
	    }
   pop_err_msg();
	return buffer;
   }
/* -------------------------------------------------------------------- */
typedef struct
{  char *name;
	int  sym;
	int  cen;
   float x[3];
	float t[3];
	char  sym_code[10];
	} TARGET_ATOM;
	/* -------------------------------------------------------------------- */
static void cif_print_sym(void)
{  int i,j, isym, icentro, ncentro, centre;
   float *sym_coef;
   float c[5][4], tt;
   int k , t, nsym;
   current_symgrp=l_phase->symgrp;
   t = 1;
   memset (&c[0][0],0, 20*sizeof(float));
   switch (current_symgrp->bravais)
   {  case 'A' :  c[1][1]=c[1][2]=0.5;  t=2; break;
      case 'B' :  c[1][0]=c[1][2]=0.5;  t=2; break;
      case 'C' :  c[1][0]=c[1][1]=0.5;  t=2; break;
      case 'I' :  c[1][0]=c[1][1]=c[1][2]=0.5;  t=2; break;
      case 'F' :  c[1][1]=c[1][2]=0.5;
                  c[2][0]=c[2][2]=0.5;
                  c[3][0]=c[3][1]=0.5;  t=4; break;
      case 'R' :  c[1][0]=c[1][1]=c[2][2]=1.0/3.0;
                  c[2][0]=c[2][1]=c[1][2]=2.0/3.0;  t=3; break;
      }
   ncentro = ( current_symgrp->centro == 0) ? 1 : 2;

   switch (current_symgrp->systeme)
	{   case 'C' : cif_string("_symmetry_cell_setting","'cubic'");
	               break;
	    case 'Q' : cif_string("_symmetry_cell_setting","'quatratic'");
	               break;
	    case 'H' : cif_string("_symmetry_cell_setting","'hexagonal'");
	               break;
	    case 'R':
		 case 'T' : cif_string("_symmetry_cell_setting","'trigonal'");
	               break;
	    case 'O' : cif_string("_symmetry_cell_setting","'orthorhombic'");
	               break;
	    case 'L' : case 'M' :
		 case 'N' : cif_string("_symmetry_cell_setting","'monoclinic'");
	               break;
	    case 'A' : cif_string("_symmetry_cell_setting","'triclinic'");
	               break;
	    }
   fprintf(cif_fich,"#      %s  %s\n", current_symgrp->nom, current_symgrp->comment );
	fprintf(cif_fich,"loop_\n");
	fprintf(cif_fich,"_symmetry_equiv_pos_site_id\n");
	fprintf(cif_fich,"_symmetry_equiv_pos_as_xyz\n");
  	nsym = 1;
	for (k=0; k<t; k++)
	{  for (icentro=0,centre=1 ; icentro<ncentro; icentro++, centre=-1)
	   for (isym=0, sym_coef = current_symgrp->coef; isym < current_symgrp->nops; isym++, sym_coef += 12)
      {  fprintf(cif_fich, " %2d    ", nsym);
         for (i=0; i<3; i++)
         {   int first=1;
			    for (j=0; j<3; j++) if ( sym_coef[i+3*j] ) 
			    {  float v = centre * sym_coef[i+3*j];
				    if ( v < 0) { v =-v; fprintf(cif_fich, "-"); }
					 else if ( !first ) fprintf(cif_fich, "+");
					 if (v >1.5) { fprintf(cif_fich, "%.0f",v+0.5); }
					 fprintf(cif_fich, "%c", 'x'+j);
					 first = 0;
					 }
				tt = centre * sym_coef[i+9] + c[k][i];
				if ( tt )
				{ int nt, dt, it;
				  if (tt < 0) { fprintf(cif_fich, "-"); tt = -tt; }
				   else fprintf(cif_fich, "+");
				   nt = 12 * tt + 0.5; dt=12;
					for (it = 4; it >= 2; it--)
					  if ( nt %it == 0 && dt %it == 0) { nt /=it; dt /=it; }
					fprintf(cif_fich, "%d",nt);
					if (dt > 1)fprintf(cif_fich, "/%d", dt);
				   }
				fprintf(cif_fich, "%c", i==2?'\n':',');
            }
		    nsym++;
			 }
		}	 
	fprintf(cif_fich, "\n");
   }
	/* -------------------------------------------------------------------- */
static void cif_search_bonds(FILE *map_fich)
{  float x0[3], x[3], c[5][4], y[3], d, e, f, g, gc, gv[3], z[3];
   float *sym_coef;
	float eps = 0.001;
   int icentro, ncentro, centre;
	int i, j, isym, k, t, at0, kk;
	int ix,iy,iz,icode;
	int found, target_start;
	int target_number = 0;
	int size, target_size = 0;
	int *start_number;
	TARGET_ATOM *target, *l_target, *m_target;
	push_err_msg("cif_search_bonds");
	if ((prt_cif & 1024) == 0) 
	{  fprintf(cif_fich,"loop_\n");
      fprintf(cif_fich,"_geom_bond_atom_site_label_1\n");
      fprintf(cif_fich,"_geom_bond_atom_site_label_2\n");
      fprintf(cif_fich,"_geom_site_symmetry_2\n");
      fprintf(cif_fich,"_geom_bond_distance\n");
      fprintf(cif_fich,"_geom_bond_publ_flag\n");
		}
   if (map_fich ) fprintf(map_fich,"# unitary cell content of %s\n", l_phase->nom);
   current_symgrp=l_phase->symgrp;
   t = 1;
   memset (&c[0][0],0, 20*sizeof(float));
   switch (current_symgrp->bravais)
   {  case 'A' :  c[1][1]=c[1][2]=0.5;  t=2; break;
      case 'B' :  c[1][0]=c[1][2]=0.5;  t=2; break;
      case 'C' :  c[1][0]=c[1][1]=0.5;  t=2; break;
      case 'I' :  c[1][0]=c[1][1]=c[1][2]=0.5;  t=2; break;
      case 'F' :  c[1][1]=c[1][2]=0.5;
                  c[2][0]=c[2][2]=0.5;
                  c[3][0]=c[3][1]=0.5;  t=4; break;
      case 'R' :  c[1][0]=c[1][1]=c[2][2]=1.0/3.0;
                  c[2][0]=c[2][1]=c[1][2]=2.0/3.0;  t=3; break;
      }
   ncentro = ( current_symgrp->centro == 0) ? 1 : 2;
   target_size = size = 8 * l_phase->n_atom * t * current_symgrp->nops;
	target = (TARGET_ATOM *) malloc (size*sizeof(TARGET_ATOM));
   start_number = (int *) malloc (l_phase->n_atom*sizeof(int));
   for (at0=0,l_atom=l_phase->atom; at0<l_phase->n_atom;at0++,l_atom++)
	{  var_init(l_atom->x);
	   for (i=0; i<3;i++) x0[i]=var_valeur(i);
		start_number[at0] = target_start = target_number;
	/* store starting atom first */
	if (target_number >= target_size)
	{	target_size +=size;
		target = (TARGET_ATOM *) realloc (target,target_size*sizeof(TARGET_ATOM));
      }
	l_target=target+target_number++;	
	l_target->name=l_atom->nom;
	l_target->sym=0;
	l_target->cen=1;
	sprintf(l_target->sym_code,".");
	for (i=0; i<3; i++) l_target->x[i]=x0[i];
	for (i=0; i<3; i++) l_target->t[i]=0;
	if (map_fich && x0[0] >= 0 && x0[0] < 1 && x0[1] >= 0 && x0[1] < 1 && x0[2] >= 0 && x0[2] < 1 )
      fprintf(map_fich,"%s        %8.3f %8.3f %8.3f\n", 
		       l_target->name,  x0[0],x0[1],x0[2]);

	for (icentro=0,centre=1 ; icentro<ncentro; icentro++, centre=-1)
	for (isym=0, sym_coef = current_symgrp->coef; isym < current_symgrp->nops; isym++, sym_coef += 12)
   {  for (i=0; i<3; i++)
          x[i] = centre * (sym_coef[i] * x0[0] + sym_coef[i+3] * x0[1]
	            + sym_coef[i+6] * x0[2] + sym_coef[i+9] );
		for (k=0; k<t; k++)
      {  for (ix=-2;ix<=2;ix++)
		   {   y[0] = x[0]+c[k][0]+ix;
				 if ( fabs(y[0]) >= 2) continue;
			for (iy=-2;iy<=2;iy++)
			{   y[1] = x[1]+c[k][1]+iy;
				 if ( fabs(y[1]) >= 2) continue;
             for (iz=-2;iz<=2;iz++)
			{   y[2] = x[2]+c[k][2]+iz;
				 if ( fabs(y[2]) >= 2) continue;
			
				found = -1;
				for ( j=target_start ; j< target_number; j++)
				{   l_target=target+j;	
					 e=fabs(l_target->x[0]-y[0])+fabs(l_target->x[1]-y[1])+fabs(l_target->x[2]-y[2]);
		          if (e < eps) { found = j; break;}
                }
            if ( found == -1 )
				{  if (target_number >= target_size)
				   {	 target_size +=size;
					    target = (TARGET_ATOM *) realloc (target,target_size*sizeof(TARGET_ATOM));
                   }
					l_target=target+target_number++;	
					l_target->name=l_atom->nom;
					l_target->sym=isym;
					l_target->cen=centre;
					icode = 1 + isym + current_symgrp->nops * (icentro + centro * k);
					if ( ix == 0 && iy == 0 && iz == 0) sprintf(l_target->sym_code,"%d", icode);
					else sprintf(l_target->sym_code,"%d_%d%d%d", icode,ix+5,iy+5,iz+5);
					for (i=0; i<3; i++) l_target->x[i]=y[i];
					for (i=0; i<3; i++) l_target->t[i]=y[i]-x[i];
					if (map_fich && y[0] >= 0 && y[0] < 1 && y[1] >= 0 && y[1] < 1 && y[2] >= 0 && y[2] < 1 )
                  if ((prt_cif & 1024) == 0 )  
						      fprintf(map_fich,"%s(%c%d_%d)  %8.3f %8.3f %8.3f\n", 
		                     l_target->name,  l_target->cen==1?'+':'-', l_target->sym, k,
				               y[0],y[1],y[2]);
					} /* found */
  				} } } } /* k ix iy iz */
         }  /* isym */ /* centro */
      } /* atoms */
   if ((prt_cif & 1024) == 0) 
	{   for (at0=0,l_atom=l_phase->atom; at0<l_phase->n_atom;at0++,l_atom++)
	{  target_start = start_number[at0];
	   l_target=target+target_start;	
		for (i=0; i<3; i++) x[i]=l_target->x[i];
      for (k=target_start+1; k < target_number; k++)
		{	l_target = target+k;	
		   for (i=0; i<3; i++) y[i]=l_target->x[i]-x[i];
         d = scalaire(y,gv,y);
			if (d > CIF_BOND_SQUARE) continue;
			d = sqrt(d);
         fprintf(cif_fich, "%6s  %6s %6s %8.3f  ?\n", 
		      l_atom->nom, l_target->name,l_target->sym_code, d);
		}	} }
   if ((prt_cif & 512) == 0 ) 
	{
	fprintf(cif_fich,"\nloop_\n");
   fprintf(cif_fich,"_geom_angle_atom_site_label_1\n");
   fprintf(cif_fich,"_geom_angle_atom_site_label_2\n");
   fprintf(cif_fich,"_geom_angle_atom_site_label_3\n");
   fprintf(cif_fich,"_geom_site_symmetry_1\n");
   fprintf(cif_fich,"_geom_site_symmetry_3\n");
   fprintf(cif_fich,"_geom_angle\n");
   fprintf(cif_fich,"_geom_angle_publ_flag\n");
   for (at0=0,l_atom=l_phase->atom; at0<l_phase->n_atom;at0++,l_atom++)
	{  target_start = start_number[at0];
	   l_target=target+target_start;	
		for (i=0; i<3; i++) x[i]=l_target->x[i];
      for (k=0; k < target_number; k++)
		{	if (k==target_start) continue;
		   l_target = target+k;	
		   for (i=0; i<3; i++) y[i]=l_target->x[i]-x[i];
         d = scalaire(y,gv,y);
			if ( d > CIF_BOND_SQUARE || d < 1) continue;
      for (kk=k+1; kk < target_number; kk++)
		{	if (kk==target_start) continue;
		   m_target = target+kk;	
		   for (i=0; i<3; i++) z[i]=m_target->x[i]-x[i];
         e = scalaire(z,gv,z);
			if ( e > CIF_BOND_SQUARE || e < 1) continue;
			for (i=0; i<3; i++) x0[i]=l_target->x[i]-m_target->x[i];
			f = scalaire(x0,gv,x0);
			if ( f > 4*CIF_BOND_SQUARE || f < 1) continue;
			gc = (f-d-e)/sqrt(d*e)/2.0;
			g = 180.0 - acos(gc)/RAD;
         fprintf(cif_fich, "%6s  %6s   %6s  %6s %6s  %8.2f ?\n", 
		      l_target->name, l_atom->nom, m_target->name,
				l_target->sym_code, m_target->sym_code, g);
		} } } }
	fprintf(cif_fich,"\n");
   free(target);
	free(start_number);
	pop_err_msg();
}
/* ------------------------------------------------------------------ */
