static char *cvs_id =" $Id: xnd_lst.c,v 1.4 2002/06/19 09:57:17 berar Exp $ ";
/* XND_lst.C       listing  */

#define USE_VAR
#define USE_SETS
#define USE_MODUL
#define USE_SCAN
#define USE_EXPER
#define USE_ATOM
#define USE_PHASE
#define USE_PENAL
#include "../xnd_def.h"
#include <string.h>
#include <ctype.h>

static int (*check_fput)(TYPE_VAR *var);
static void prt_rad_dist(P_(void));
static void prt_rdf_peak(P_(void));
/* ------------------------------------------------------------------ */
static int fput_sets_hkl (P_(void))
{  int i, nb_sets;
   int chk = 0;
   nb_sets = l_phase->nb_sets;
   current_sets = l_phase->sets;
   for (i=0; i==0 ||i<nb_sets; i++, current_sets++) if (current_sets->nb_hkl > 0)
   {   chk += (*check_fput)(current_sets->intensity);
       }
   return chk;
	}
/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */
void imprime (P_(int) do_print, P_(int) allow_end, P_(int) saving)
{   int    i,i_phase,j;
    PENAL_PTR p_dist;
    PENAL_PTR p_angl;
    SETS_PTR l_sets;
	 char * entete;
    int print, chk_result;
    int chk_loop = 0;
    push_err_msg("Printing cycle results");
   entete =
"   #     variable       (o)      value           sigma            shift     shift/sigma\n";
   fini = allow_end;
   if (prt_cif && prt_cif != -1)
	{	cif_fich = tst_open (cif_name,"w","CIF file");
	   fprintf(cif_fich,"# file used to generate the cif structure\n");
	   fprintf(cif_fich,"# it appears only if xnd was interrupted\n");
	   fprintf(cif_fich,"# or followed by cif data in tests (prt_cif=8)\n");
	   fprintf(cif_fich,"# --------------------------------------------\n");
	   }
	print = 0;
	check_fput = var_check;
	if (print) fprintf(list_fich,"\n");
   while ( 1 )
	{  var_init_loop (saving, print, chk_loop); 
	   chk_result = 0;
      for (i=0,l_exper = exper;i<n_exper;(i++,l_exper++)) 
		if (l_exper->n_var)
      {  if (print) fprintf(list_fich," EXPER : %s\n%s", l_exper->nom, entete);
         chk_result += (*check_fput)(l_exper->onde);
         chk_result += (*check_fput)(l_exper->back);
         chk_result += (*check_fput)(l_exper->reglage);
         chk_result += (*check_fput)(l_exper->instru);
         chk_result += (*check_fput)(l_exper->ascnv);
         chk_result += (*check_fput)(l_exper->asym);
		   if (l_exper->nature & EXPER_ENER_RESOL ) chk_result += (*check_fput)(l_exper->c_exp);
         }
	  for (i_phase=0,l_phase = phase;i_phase<n_phase;i_phase++,l_phase++)
	  if (l_phase->n_var)
     {  if (print) fprintf(list_fich," PHASE : '%s'\n%s", l_phase->nom, entete);
        chk_result += (*check_fput)(l_phase->ech);
        chk_result += (*check_fput)(l_phase->transit);
        chk_result += (*check_fput)(l_phase->cell);
        if (l_phase->nature >= PHASE_GENERE || l_phase->magnet || l_phase->modul)
        {  if (l_phase->vector) chk_result += (*check_fput)(l_phase->vector);
           chk_result += (*check_fput)(l_phase->orien);
           current_modul = l_phase->modul;
		     if ( l_phase->sets && l_phase->m_prof ) 
			    for(j=0,l_sets=l_phase->sets;j<l_phase->nb_sets;j++,l_sets++)
		         chk_result += (*check_fput)((l_sets->prof));
		     else chk_result += (*check_fput)(l_phase->prof);
           chk_result += (*check_fput)(l_phase->asym);
           if (l_phase->nb_atom)
           {  for (j=0,l_atom=l_phase->atom;j<l_phase->n_atom;j++,l_atom++)
              {  chk_result += (*check_fput)(l_atom->x);
                 if (l_atom->n_modul)  chk_result += (*check_fput)(l_atom->modul);
                 if (l_atom->n_anharm) chk_result += (*check_fput)(l_atom->anharm);
                 }
              if (l_phase->nb_bloc)
              {  chk_result += (*check_fput)(l_phase->bloc);
                 for (i=0;i<l_phase->nb_bloc;i++)
                 {  for (j=0,l_atom=l_phase->bl_ortho[i]; j<l_phase->bl_atom[i];j++,l_atom++)
                       chk_result += (*check_fput)(l_atom->x);
                       if ( l_atom->n_modul) chk_result += (*check_fput)(l_atom->modul);
                    }
                 }
              if (l_phase->uncoherent & DIF_TDS_HKL) chk_result += (*check_fput)(l_phase->tds);
              if (l_phase->nb_bond)
              {  p_dist = l_phase->dist;
                 for(i=0;i<l_phase->nb_dist;i++,p_dist++)
                   chk_result += (*check_fput)(p_dist->dist);
                 p_angl = l_phase->angl;
                 for(i=0;i<l_phase->nb_angl;i++,p_angl++)
                   chk_result += (*check_fput)(p_angl->dist);
                 }
               }
             else chk_result += fput_sets_hkl ();
             }
          else switch (l_phase->nature)
          {  case PHASE_RADIAL :
               for (j=0,l_atom=l_phase->atom;j<l_phase->n_atom;j++,l_atom++)
                    chk_result += (*check_fput)(l_atom->x);
               chk_result += (*check_fput)(l_phase->radial);
               break;
             case PHASE_RDFPEAK :
               chk_result += (*check_fput)(l_phase->radial);
               break;
             case PHASE_PARASITE :
               chk_result += (*check_fput)(l_phase->prof);
               chk_result += fput_sets_hkl ();
               break;
             case PHASE_QUASI :
               chk_result += (*check_fput)(l_phase->prof);
               chk_result += fput_sets_hkl ();
            }
        }
	  saving = 0;
     if (check_fput == var_fput) break;
	  if (chk_result == 0 || chk_loop > n_par)
	  {  check_fput = var_fput;
		  print = do_print;
		  } else
     {   verbose_printf(" %d shift(s) wil be shortened due to non-linear boundaries in vars at pass %d\n",
         chk_result, chk_loop++);
         }
	  }  /* while chk */
   fflush (list_fich); 
	var_end_loop();
 	cif_fich = xclose(cif_fich);
   pop_err_msg();
   }

/* ------------------------------------------------------------------ */
void prt_u_equiv(P_(void))
{   int i,j,k,im,it,ij;
    float b, uij[6];
    push_err_msg("prt_u_equiv(xnd_lst.c)");
    fprintf(list_fich,"\n");
    for (im=0,l_exper=exper;im<n_exper;im++,l_exper++)
     for (it=0,l_diag=l_exper->diag;it<l_exper->n_diag;it++,l_diag++)
    {
    for (i=0,l_phase = phase;i<n_phase;i++,l_phase++)
    switch ( l_phase->nature )
    {  case PHASE_RADIAL   : prt_rad_dist(); break;
	    case PHASE_PARASITE : 
	    case PHASE_QUASI    : break;
		 case PHASE_RDFPEAK  : prt_rdf_peak(); break;
	    default       : 
    {   temp = &temp_phase;
        temp_phase = l_diag->temp - l_phase->temp_orig;
        ini_metric();
        if (l_phase->n_atom)
        {  k = 0;
           fprintf(list_fich," PHASE : '%s' at %.3f\n",
               l_phase->nom, l_diag->temp);
           for (j=0,l_atom=l_phase->atom;j<l_phase->n_atom;j++,l_atom++)
            if ((l_atom->nature & B_ANISO) == 0) k++;
           if (k != 0)
           {  fprintf(list_fich," %6s  %7s  %7s %12s %9s %9s %9s  b12=b13=b23=0\n","",
		          "B_iso","U_equiv","U11=U22=U33", "b11", "b22", "b33");
              for (j=0,l_atom=l_phase->atom;j<l_phase->n_atom;j++,l_atom++)
               if ((l_atom->nature & B_ANISO) == 0)
              {  fprintf(list_fich," %6s ",l_atom->nom);
				     var_init(l_atom->x);
				     b=var_valeur(4)/(8*M_PI*M_PI);
				     uij[0]=b;
	              fprintf(list_fich," %7.3f  %7.3f    %7.4f     %9.6f %9.6f %9.6f\n",
                   b*(8*M_PI*M_PI), b, uij[0],uij[0]*g_aa,uij[0]*g_bb,uij[0]*g_cc);
	              }
              }/* if ( k != 0 ) */
           if ( k != l_phase->n_atom)
           {  fprintf(list_fich," %6s  %7s  %7s  %7s %7s %7s %7s %7s %7s\n","",
		          "B_iso","U_equiv","U11", "U22", "U33", "U12", "U13", "U23");
              for (j=0,l_atom=l_phase->atom;j<l_phase->n_atom;j++,l_atom++)
              if (l_atom->nature & B_ANISO)
              {  fprintf(list_fich," %6s ",l_atom->nom);
                 b = u_equiv(l_atom->x, uij);
	              fprintf(list_fich," %7.3f %7.3f   ", b*(8*M_PI*M_PI), b);
	              for (ij=0; ij < 6; ij++) fprintf(list_fich," %7.4f", uij[ij]);
                 fprintf(list_fich,"\n");
                 }
               }  /* if ( k != l_phase->n_atom) */
            } /* if (l_phase->n_atom) */
		    }		}
      }
   pop_err_msg();  
   }
/* ------------------------------------------------------------------ */
void prt_correl(P_(void))
{    int i,j,ii;
     int n = 0;
     int m = 0;
     char *errsi;
     float *si, sij;
     float niveau;
     if (n_par==1) return;
     fprintf (list_fich,"\n Correlations %d parametres\n",n_par);
     if (prt_cor>1)
     {  niveau = prt_cor / 10.0;
        fprintf (list_fich," Valeurs superieures a %f (prt_corel = %d)\n",niveau,prt_cor);
        }
     else niveau = 0;
     si = (float*)tst_alloc(n_par, sizeof(float),"prt_correl");
     errsi = (char*)tst_alloc(n_par, sizeof(char),"prt_correl");
     for (i=0;i<n_par;i++)
     {   ii = (i*(i+1))/2;
         errsi[i] = 0;
         if ( (sij=matrice[ii+i]) > 0 ) si[i] = sqrt(sij); 
	 else { si[i] = 0; errsi[i]=1; }
	 }
     for (i=0;i<n_par;i++)
     {   ii = (i*(i+1))/2;
         for (j=0;j<i;j++,n++)
         {   sij= matrice[ii+j];
             if (prt_cor==1 || fabs(sij)>niveau*si[i]*si[j] )
             {  m++;
                fprintf (list_fich," %3d %3d  ", j+1, i+1);
                fprintf (list_fich,"%+6.3f",sij/si[i]/si[j]);
                fprintf (list_fich,"%s", (m % 5 == 4) ? "\n" : "    ");
            }   }
        }
     fprintf (list_fich,"\n");
     free( si);
     free(errsi);
     }
/* ------------------------------------------------------------------ */
static void prt_rad_dist(P_(void))
{  int nd, nv, ic, n;
   float *coef, *dist, qq, *a_coef, *d_coef;
   if ( l_phase->nb_dist > 0)
   {  nd = l_phase->nb_dist;
      nv = nd;
      }
   else 
   {  nd = -l_phase->nb_dist;
      nv = -nd*l_phase->n_atom;
      } 
	coef = (float *) tst_alloc (nv, sizeof(float),"distrib");
   temp = &temp_phase;
   var_init(l_phase->radial);
	for (ic=0; ic<nv;ic++) coef[ic]=var_valeur(ic);
   dist = (float *) l_phase->radial->link;
	for (n=0;n<nd;n++)
	{  int in = n/nd;
            int jn = n%nd;
            float dr;
            float bqq = qq*dist[n];
            if (jn == 0)  dr = dist[n+1]-dist[n];
            else if (jn == nd-1)  dr = dist[n]-dist[n-1];
            else           dr = 0.5*(dist[n+1]-dist[n-1]);
				d_coef[n] = (qq > EPSILON) ? (4 * M_PI) * dist[n] * dr * sin(bqq)/qq : 0;
            a_coef[in] += coef[n] * d_coef[n]; 
				}  
   free(coef);
   }
/* ------------------------------------------------------------------ */
static void prt_rdf_peak(P_(void))
{  int  n_dist, n_steps, n;
   float rstep, rlim, rho0, rmin, phase_echelle;
   FILE *rdf;
   push_err_msg("prt_rdf_peak(xnd_lst.c)");
   temp = &temp_phase;
   temp_phase = l_diag->temp - l_phase->temp_orig;
   n_dist = l_phase->nb_dist;
   rstep = l_phase->bond[0];
   rlim  = l_phase->bond[1];
   rho0  = l_phase->bond[2];
   rmin  = l_phase->bond[3];
   var_init(l_phase->ech);
   phase_echelle = var_valeur (0);
   n_steps=1.5*rlim/rstep;   
	rdf = fopen("xnd_rdf.dat","w"); 
   if (rdf) fprintf(rdf , "#RDF '%s' at %.3f\n", l_phase->nom, l_diag->temp);
   for (n=1;n<n_steps;n++)
	{  int nr, ir;
      float rdfsum, rdf0, r = n * rstep;
	   rdf0 = 4 * M_PI * rho0 * r * r; 
  		if ( r >=rmin && r <= rlim)
      {  rdfsum = 0;
	      var_init(l_phase->radial);
         for (ir=nr=0; nr<n_dist; nr++, ir+=3)
         {  float amp, pos, sig, rr;
            amp = var_valeur (ir);
            pos = var_valeur (ir+1);
            sig = var_valeur (ir+2);
            rr = (r-pos)/sig;
            rdfsum += amp * exp (- 0.5*rr*rr);
            }
         } else { rdfsum = rdf0; }
	   if (rdf) fprintf(rdf , "%5.2f %8.3f %8.3f\n", r, rdfsum, rdf0);
	   }   /* n loop */ 
	if (rdf) fclose(rdf);
   pop_err_msg();  
   }
/* ------------------------------------------------------------------ */
