static char *cvs_id =" $Id: xnd_prga.c,v 1.1.1.1 2000/05/13 13:11:00 berar Exp $ ";
/* XND_PRGA.C     gauss profile function */

#define  USE_BRAGG
#include "xnd_prof.h"
/* =========================================================== */
/* gauss profile function, position derivative dp_dt        */
/* dp_dt is related to the peak position = -1 * df/dt       */
/* lorentz_width and 2*gauss_square_width derivatives       */
/* derivatives used the stored values : w_x, dt2            */
/* ----------------------------------------------------------- */
float gauss_profil (P_(void))
{   prof_dt2 = dt * dt * x_coef;
	 w_x = i_coef * exp ( - prof_dt2 );
    return (w_x);
    }
/* ----------------------------------------------------------- */
float gauss_dprof_dt (P_(void))
{   return (2 * dt * w_x * x_coef);
    }
/* ----------------------------------------------------------- */
float gauss_dprof_dg (P_(void))
{   return (w_x * ( prof_dt2 - 0.5) * (x_coef / M_2LN2));
    }
/* ----------------------------------------------------------- */
int ini_gauss (P_(void))
{    float  larg;
     larg = M_SQRT4LN2 / W_G;
     x_coef = larg * larg;
     i_coef = M_1_SQRTPI * I_C * larg;
     if (i_coef < 0.5*minimum) return (0);
     influence = 2 / larg;
     if (i_coef < minimum ) influence *=0.5;
     w_y = 0;
     prof_case =  1;
     return (1);
     }
/* ----------------------------------------------------------- */
/* for analytical convolution                                  */
/* ----------------------------------------------------------- */
float a_gauss_profil (P_(void))
{   prof_dt2 = dt * dt * x_coef;
	 w_x = i_coef * exp ( - prof_dt2 );
    return (w_x);
    }
/* ----------------------------------------------------------- */
float a_gauss_dprof_dt (P_(void))
{   return (2 * dt * w_x * x_coef);
    }
/* ----------------------------------------------------------- */
float a_gauss_dprof_dg (P_(void))
{   return (w_x * ( prof_dt2 - 0.5) * (x_coef / M_2LN2));
    }
/* ----------------------------------------------------------- */
