static char *cvs_id =" $Id: xnd_rato.c,v 1.4 2002/09/11 15:41:01 berar Exp $ ";
/* XND_RATO.C       this file read atoms data for crystal phases      */
/* ------------------------------------------------------------------ */
#define USE_VAR
#define USE_KEYS
#define USE_SYM
#define USE_MODUL
#define USE_DIFDAT
#define USE_ATOM
#define USE_PHASE
#include "../xnd_def.h"
#include "xnd_rdh.h"
/* ------------------------------------------------------------------ */
static char *txt_atom_amo[1] =
		  { "Oc" };
static char *txt_atom_iso[COORD_DIM] =
		  { "X", "Y", "Z", "Oc", "Biso", "Kx", "Ky", "Kz", "R", NULL, NULL, NULL, NULL, NULL, NULL};
static char *txt_atom_ani[COORD_DIM] =
		  { "X", "Y", "Z", "Oc", "b11", "b22", "b33", "b12", "b13", "b23",
		    "Kx", "Ky", "Kz", "R", NULL};
static char *txt_modul[AMODUL] =
		  { "S_x", "C_x", "S_y", "C_y", 
		    "S_z", "C_z", "S_Oc", "C_Oc" };
static char *txt_anharm3[COORD_ANHARM3]   = { "C111", "C222", "C333",
                             "C112", "C113", "C221", "C223", "C331", "C332", "C123"};
static char *txt_anharm4[COORD_ANHARM4]   = { "D1111", "D2222", "D3333",
                             "D1112", "D1113", "D2221", "D2223", "D3331", "D3332",
                             "D1122", "D1133", "D2233", "D1123", "D2212", "D3312"};
static char *txt_anharm5[COORD_ANHARM5]   = { "E11111", "E22222", "E33333",
                             "E11112", "E11113", "E22221", "E22223", "E33331", "E33332",
                             "E11122", "E11133", "E22211", "E22233", "E33311", "E33322", 
                             "E11123", "E22213", "E33312", "E11223", "E11332", "E22333"};
static char *txt_anharm6[COORD_ANHARM6]   = { "F111111", "F222222", "F333333",
                             "F111112", "F111113", "F222223", "F1123", "F2212", "F3312",
                             "F111122", "F111133", "F222211", "F222233", "F333311", "F333322",
                             "F111123", "F222213", "F333312",
                             "F111222", "F111333", "F222333",
                             "F111223", "F111332", "F222113", "F222331" "F333112", "F333221",
                             "F112233"};
/* ------------------------------------------------------------------ */
TYPE_ATOM *l_atom;
/* ------------------------------------------------------------------ */
static float inside(P_(float) x)
#ifdef NOPROTO
float x;
#endif
{	while ( x >= 1.0 ) x -= 1.0;
	while ( x < 0.0 )  x += 1.0;
   return x;
   }
/* ------------------------------------------------------------------ */
static float dproj(P_(float) dx)
#ifdef NOPROTO
float x;
#endif
{	dx = fabs(dx);
   if ( dx > 0.5 ) dx = 1-dx;
   return dx;
   }
/* ------------------------------------------------------------------ */
#define SYM_MOD 48.0
static int atom_mult (P_(float *) xo, P_(int *) n, P_(int *) inv_p, P_(float *) inv_c, P_(int) verbose)
#ifdef NOPROTO
float *xo, *inv_c;
int *n, *inv_p;
int verbose;
#endif
{  float x[3], c[5][4], y, d, e;
   float *sym_coef;
   TYPE_ATOM *atom;
   int isym, i, ii, j, k, t, mult = 0;
   push_err_msg("atom_mult");
   *n = current_symgrp->nops;
   if (current_symgrp->centro ) *n *=2;
   t = 1;
   memset (&c[0][0],0, 20*sizeof(float));
   switch (current_symgrp->bravais)
   {  case 'A' :  c[1][1]=c[1][2]=0.5;  t=2; break;
      case 'B' :  c[1][0]=c[1][2]=0.5;  t=2; break;
      case 'C' :  c[1][0]=c[1][1]=0.5;  t=2; break;
      case 'I' :  c[1][0]=c[1][1]=c[1][2]=0.5;  t=2; break;
      case 'F' :  c[1][1]=c[1][2]=0.5;
                  c[2][0]=c[2][2]=0.5;
                  c[3][0]=c[3][1]=0.5;  t=4; break;
      }
	if (current_modul)
	{  float *s4 = current_modul->center_4d;
	   switch (current_symgrp->bravais)
      {  case 'A' :  if (s4[1] || s4[2]) c[1][3]=.5;  break;
         case 'B' :  if (s4[0] || s4[2]) c[1][3]=.5;  break;
         case 'C' :  if (s4[0] || s4[1]) c[1][3]=.5;  break;
         case 'I' :  if (s4[0] || s4[1] || s4[2]) c[1][3]=.5;  break;
         case 'F' :  if (s4[1] || s4[2]) c[1][3]=.5;
			            if (s4[0] || s4[2]) c[2][3]=.5;
			            if (s4[0] || s4[1]) c[3][3]=.5;  break;
      }  }
   *n*=t;
   for (isym=0, sym_coef = current_symgrp->coef; isym < current_symgrp->nops; isym++, sym_coef += 12)
   {  for (j=0; j<3; j++)
          x[j] = inside(sym_coef[j] * xo[0] + sym_coef[j+3] * xo[1]
	            + sym_coef[j+6] * xo[2] + sym_coef[j+9]);
      if (verbose) fprintf(list_fich, " %s  sym %d ", l_atom->nom, isym, x[0],x[1],x[2]);
      for (k=0; k<t; k++)
      {  e =0;
         if (verbose) fprintf(list_fich, " (");
         for (j=0; j<3; j++)
         {  y = inside(x[j]+c[k][j]);
            if (verbose) fprintf(list_fich, "%6.3f ", y);
            e += dproj(y-xo[j]);
            }
         if ( e < 0.001 )
			{  mult++;
			   i=isym+k*current_symgrp->nops;
            if(c[k][3]==0) inv_p[i]=1; else inv_p[i]=SYM_MOD/c[k][3];
            memcpy(inv_c+12*i,current_symgrp->coef+12*isym, 9*sizeof(float));
				}
         if (verbose) fprintf(list_fich, ")%c", e < 0.001 ? '=':' ');
         }
      if ( current_symgrp->centro)
	   {  if (verbose) fprintf(list_fich, "\n %s  inv*%d ", l_atom->nom, isym);
         for (k=0; k<t; k++)
         {  e= 0;
            if (verbose) fprintf(list_fich, " (");
            for (j=0; j<3; j++)
            {  y = inside(-x[j]+c[k][j]);
               if (verbose) fprintf(list_fich, "%6.3f ", y);
               e += dproj(y-xo[j]);
               }
            if (verbose) fprintf(list_fich, ")%c", e < 0.001 ? '=':' ');
            if ( e < 0.001 )
			   {  mult++;
			      i=isym+(k+t)*current_symgrp->nops;
               if(c[k][3]==0) inv_p[i]=1; else inv_p[i]=-SYM_MOD/c[k][3];
               for (ii=0;ii<9;ii++) inv_c[12*i+ii] = - current_symgrp->coef[12*isym+ii];
				   }
            }
	      } /* centro */
      if (verbose) fprintf(list_fich, "\n");
      } /* isym */
   pop_err_msg();
   return mult;
   }
/* ------------------------------------------------------------------ */
static void atom_sym (P_(int) m0, P_(float *) xo, P_(int *) inv_p, P_(float *) inv_c, P_(TYPE_SYMGRP *) sym4)
#ifdef NOPROTO
int m0;
float * xo;
int *inv_p;
float *inv_c;
SYMGRP *sym4;
#endif
{  int i, j, k, n;
   int cas =0;
	char *x,*y,*z,vx[6],vy[6],vz[6];
	float epsilon, tau;
	int num_tau, deno_tau;
   push_err_msg("atom_sym");
	memset(inv_p, 0, 8*current_symgrp->nops);
	for ( i=0; i<3;i++)
	{  xo[i] +=.01;
		if (atom_mult(xo, &n, inv_p, inv_c, 0) < m0) cas |= 1<<i;
	   xo[i] -=.01;
		}
/*	if (cas & 3 == 0);      */
	num_deno(xo[0], &num_tau, &deno_tau);
	if (num_tau) sprintf(vx,"%d/%d", num_tau, deno_tau);
	else sprintf(vx,"0");
	num_deno(xo[1], &num_tau, &deno_tau);
	if (num_tau) sprintf(vy,"%d/%d", num_tau, deno_tau);
	else sprintf(vy,"0");
	num_deno(xo[2], &num_tau, &deno_tau);
	if (num_tau) sprintf(vz,"%d/%d", num_tau, deno_tau);
	else sprintf(vz,"0");
	x=vx; y=vy; z=vz;
	switch (cas)
	{  case 0 : x="x"; y="y"; z="z";break;
	   case 1 : x=vx; y="y"; z="z"; break;
	   case 2 : x="x"; y=vy; z="z"; break;
	   case 3 : x=vx; y=vy; z="z"; break;
	   case 4 : x="x"; y="y"; z=vz; break;
	   case 5 : x=vx; y="y"; z=vz; break;
	   case 6 : x="x"; y=vy; z=vz; break;
	   case 7 : x=vx; y=vy; z=vz; break;
	   case 8 : x="x"; y="y"; z=vz; break;
		default : x = y = z = "?";
	   }
	fprintf(list_fich," special position (orthorhombic check : 3,4,6 axis ignored) %d : %s, %s, %s\n", cas, x, y, z);
	if (cas && sym4) 
	{  char key[12];
	   int in, nn;
		memset(key,'1',12);
	   fprintf( list_fich, " %s symmetry study (DON'T USE, needs to be validated)\n", sym4->nom);
		for (j=1;j<n;j++) if ( inv_p[j] )
	   {	i=j%current_symgrp->nops;
			if ( j < 4*current_symgrp->nops )
			{  epsilon = sym4->coef[2*i];
			   tau = sym4->coef[2*i+1];
				}
			else
			{  epsilon = -sym4->coef[2*i];
			   tau = -sym4->coef[2*i+1];
				}
			if (inv_p[j] != 1) tau += SYM_MOD/inv_p[j];
			tau -= floor(tau);
			num_deno( tau, &num_tau, &deno_tau);
			fprintf(list_fich," wave symmetry ");
		   fprint_xyz_pos(list_fich, inv_c+12*j, ' ');
			fprintf(list_fich," (%cT", (epsilon > 0)? '+': '-');
			if (num_tau) fprintf(list_fich,"%+d/%d",num_tau, deno_tau);
			fprintf(list_fich,") restriction : ");
			if (epsilon > 0)
			{  if (num_tau == 0)
			   {  for (in=0,nn=0; in<3;in++) if(inv_c[12*j+4*in] < 0 )
					{   key[2*in] = '0'; key[2*in+1]='0';
					    key[2*in+6] = '0'; key[2*in+7]='0';
					    fprintf(list_fich," S_%c C_%c", 'x'+in, 'x'+in);
						 nn++;
						 }
				   if (nn) fprintf(list_fich," for 1q and 2q\n" );
					else   fprintf(list_fich," none for 1q and 2q\n" );
               } /*tau == 0 */
			   else if ( num_tau == 1 && deno_tau == 2)
			   {  for (in=0,nn=0; in<3;in++) if(inv_c[12*j+4*in] > 0 )
					{   key[2*in] = '0'; key[2*in+1]='0';
					    fprintf(list_fich," S_%c C_%c", 'x'+in, 'x'+in);
						 nn++;
						 }
				   if (nn) fprintf(list_fich," not allowed for 1q " );
					for (in=0,nn=0; in<3;in++) if(inv_c[12*j+4*in] < 0 )
					{   key[2*in+6] = '0'; key[2*in+7]='0';
					    fprintf(list_fich," S_%c C_%c", 'x'+in, 'x'+in);
						 nn++;
						 }
				   if (nn) fprintf(list_fich," for 2q " );
					fprintf(list_fich,"\n" );
               } /*tau == 1/2 */
			  else  fprintf(list_fich,"unchecked \n");
	        }
		 else	 /* epsilon */
			{  if (num_tau == 0)
			   {  for (in=0,nn=0; in<3;in++) if(inv_c[12*j+4*in] < 0 )
					{   key[2*in] = '0';  
					    key[2*in+6] = '0'; 
					    fprintf(list_fich," S_%c", 'x'+in);
						 nn++;
						 }
					else 
					{   key[2*in+1]='0'; 
					    key[2*in+7]='0'; 
					    fprintf(list_fich," C_%c", 'x'+in);
						 nn++;
						 }
				   if (nn) fprintf(list_fich," for 1q and 2q\n" );
					else   fprintf(list_fich,"\n" );
               } /*tau == 0 */
			   else if ( num_tau == 1 && deno_tau == 2)
			   {  for (in=0,nn=0; in<3;in++) if(inv_c[12*j+4*in] < 0 ) 
					{   key[2*in] = '0';  
					    fprintf(list_fich," S_%c", 'x'+in);
						 nn++;
						 }
					else 
					{   key[2*in+1]='0'; 
					    fprintf(list_fich," C_%c", 'x'+in);
						 nn++;
						 }
				   if (nn) fprintf(list_fich," for 1q " );
					for (in=0,nn=0; in<3;in++) if(inv_c[12*j+4*in] < 0 ) 
					{   key[2*in+7] = '0'; 
					    fprintf(list_fich," C_%c", 'x'+in);
						 nn++;
						 }
					else 
					{   key[2*in+6]='0'; 
					    fprintf(list_fich," S_%c", 'x'+in);
						 nn++;
						 }
				   if (nn) fprintf(list_fich," for 2q" );
					fprintf(list_fich,"\n" );
               } /*tau == 1/2 */
			  else  fprintf(list_fich," unchecked \n");
	        } /* epsilon  == -1 */
		 }
		 fprintf(list_fich, " summary (Sin,Cos) : (1q) x(%c,%c) y(%c,%c) z(%c,%c) (2q) x(%c,%c) y(%c,%c) z(%c,%c)\n",
		     key[0],key[1],key[2],key[3],key[4],key[5],key[6],key[7],key[8],key[9],key[10],key[11]);
		 }  /* if sym4 */
   pop_err_msg();
   return;
	}
/* ------------------------------------------------------------------ */
static float atom_site (P_(char *) sym_name, P_(TYPE_SYMGRP *) sym4)
#ifdef NOPROTO
char * sym_name;
SYMGRP *sym4;
#endif
{  float xo[3], e;
   int verbose;
   int j, n, mult;
	int * inv_p;
   float * inv_c;
   push_err_msg("atom_site");
   verbose = lect->prt_sym & 4;
	inv_p = (int *)tst_alloc(8,current_symgrp->nops*sizeof(int),"atom_site");
	inv_c = (float *)tst_alloc(12*8,current_symgrp->nops*sizeof(float),"atom_site");
   var_init(l_atom->x);
   e = var_valeur(3);
   for (j=0; j<3; j++) xo[j] = inside(var_valeur(j));
   mult = atom_mult(xo, &n, inv_p, inv_c, verbose);
   if (mult) 
   {  if (sym_name) fprintf (list_fich, " Using %s,", sym_name);
      fprintf (list_fich,
         " %s generates %d(%d/%d) sites corresponding to %.2f(%.2f*%d) atoms in the cell\n The chemical occupancy is then %.3f",
          l_atom->nom, n/mult, n, mult, e*n, e, n, e*mult);
      if (n != mult && (lect->prt_sym & 8)) atom_sym(mult, xo, inv_p, inv_c, sym4);
		fprintf (list_fich, "\n");
		n  /= mult;
		} else
   {   fprintf (list_fich,
         " %s don't generate (%d/%d) sites for the %.2f(%.2f*%d) atoms in the cell\n\n",
          l_atom->nom, n, mult, e*n, e, n);
	    n = 0;
		 }	  
      free(inv_c);
      free(inv_p);
   pop_err_msg();
   return n;
   }
/* ------------------------------------------------------------------ */
static void check_dif (P_(char *)espece_lue)
#ifdef NO_PROTO
char *espece_lue;
#endif
{   char espece[11];
    char *p_esp;
   push_err_msg("check_dif");
    l_atom->xdif = l_atom->ndif = l_atom->mdif = l_atom->uxdif = l_atom->undif = NULL;
        l_atom->adif = NULL;
    if (lect->nature & LECT_NAT_RX)
    {   strcpy (espece,"0");
        strcat (espece,espece_lue);
        p_esp = espece+1;
        while (isdigit(*p_esp)) p_esp++;
        l_atom->xdif = get_dif(p_esp,1);
        if (lect->nature & LECT_NAT_RXA) l_atom->adif = get_adif(p_esp);
        if (l_phase->uncoherent & DIF_COMPTON)
        {    p_esp--;
            *p_esp='&';
            l_atom->uxdif = get_dif(p_esp,1);
            }
        }
    if (lect->nature & LECT_NAT_N)
    {   strcpy (espece,"0");
        strcat (espece,espece_lue);
        p_esp = espece+1;
        while (isalpha(*p_esp)) p_esp++;
        *p_esp=0;
        p_esp = isalpha(espece[1]) ? espece : espece+1;
        l_atom->ndif = get_dif(p_esp,1);
        if ((lect->nature & LECT_NAT_NM) && (l_atom->nature & MAGNET))
	{   strcpy (espece,"-");
            strcat (espece,espece_lue);
            p_esp = espece;
            l_atom->mdif = get_dif(p_esp,0);
	    if (l_atom->mdif == NULL)
	    {   strcpy (espece,"_");
                strcat (espece,espece_lue);
                p_esp = espece;
                l_atom->mdif = get_dif(p_esp,1);
	    }   }
        if (l_phase->uncoherent & DIF_COMPTON)
        {   espece[0]='$';
            l_atom->undif = get_dif(p_esp,1);
            }
        }    
   pop_err_msg();
   }

/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */
TYPE_ATOM *fget_atom (P_(int) nombre, P_(int) terme)
#ifdef NO_PROTO
int nombre, terme;
#endif
{  TYPE_ATOM   *ret_atom;
   int    j, jk, cas;
	int    convert;
   char   espece[10];
   push_err_msg("fget_atom(xnd_rato.c)");
	cas=0;
   ret_atom = l_atom = (TYPE_ATOM *) tst_alloc(nombre,sizeof(TYPE_ATOM),"atoms");
   for (j=0;j<nombre;j++,l_atom++)
   {  memset(l_atom, 0, sizeof(TYPE_ATOM));
      l_atom->remark = read_remark(NULL);
      if ( get_keys( "ATOM", NULL,
          "NAME", KEYTYPE_CHAR, &(l_atom->nom), (char *) "",
          "CHEM",  KEYTYPE_CHAR, &espece, (char *) "",
          "CASE",  KEYTYPE_INT, &cas, cas,
			 "CONVERT", KEYTYPE_INT, &convert, (int) 0,
          NULL ) == -1 )
      {  jk=fscanf (coord_fich," %s %s",l_atom->nom,espece);
	      tst_abort ((jk<2), " No keys, Atom name and species not found\n");
         if (terme != -1) fscanf (coord_fich,"%d",&cas);
         }
      fprintf (list_fich," %s %s",l_atom->nom,espece);
		if ( convert ) 
		{  fprintf( list_fich," 'B_ISO=b11 to b_ANISO' ");
		   cas |=  B_ANISO ;
			}     
      if (terme != -1)
      {  fprintf (list_fich," %d:(", cas);
         l_atom->nature = cas;
         tst_abort ((cas>NATURE_MAX),"Unknown case");
         l_atom->nb = COORD_0;
         if (cas & B_ANISO) 
         {  l_atom->nb += COORD_ANIS;
            fprintf (list_fich," B_ANISO ");
            }
         else fprintf (list_fich," B_ISO ");
         if (cas & MAGNET)
         {  l_atom->nb += COORD_MAGN;
            lect->n_magnet++;
            fprintf (list_fich," MAGNET ");
            }
         l_atom->n_modul = ( cas & MODUL )>>2;
         if ( l_atom->n_modul )
         {  lect->n_modul++;
            fprintf (list_fich," MODULATED=%d ", l_atom->n_modul);
            }
         l_atom->n_anharm = 0;
         if (cas & B_ANHARM3)
         {  l_atom->n_anharm +=1;
            fprintf (list_fich," B_ANHARM3 ");
            tst_abort (((cas & (B_ANHARM-B_ANHARM3)) != 0 || l_atom->n_modul != 0 ),
               "anharmonic expansion is only valid for simple case");
            }
         if (cas & B_ANHARM4)
         {  l_atom->n_anharm +=2;
            fprintf (list_fich," B_ANHARM4 ");
            tst_abort (((cas & (B_ANHARM-B_ANHARM4)) != 0 || l_atom->n_modul != 0 ),
               "anharmonic expansion is only valid for simple case");
               }
        if (cas & B_ANHARM5)
        {  l_atom->n_anharm +=4;
           fprintf (list_fich," B_ANHARM5 ");
           tst_abort (((cas & (B_ANHARM-B_ANHARM5)) != 0 || l_atom->n_modul != 0 ),
              "anharmonic expansion is only valid for simple case");
           }
        if (cas & B_ANHARM6)
        {  l_atom->n_anharm +=8;
           fprintf (list_fich," B_ANHARM6 ");
           tst_abort (( l_atom->n_modul != 0 ),
              "anharmonic expansion is only valid for simple case");
           }
        if (cas & F_ROTAT)
        {  l_atom->nb += 1;
            fprintf (list_fich," F_ROTAT ");
           tst_abort (( l_atom->n_modul != 0 || l_atom->n_anharm != 0 ),
              "free rotator applies only valid for simple case");
           }
       fprintf (list_fich,")");
        if (terme) tst_abort (((cas & MAGNET) != 0 || l_atom->n_modul != 0 ),
           "magnetic or modulated atoms are not allowed in rigid body");
/*        }
     else l_atom->nb = 1;   moved, so few things to do else */

     check_dif (espece);
     if (cas & B_ANISO)
	  l_atom->x=fget_var(l_atom->nb, 0, VAR_ATOM, l_atom->nom, (void **) txt_atom_ani, "COORD", NULL, 0, 0);
     else 
	  l_atom->x=fget_var(l_atom->nb, 0, VAR_ATOM, l_atom->nom, (void **) txt_atom_iso, "COORD", NULL, 0, 0);
	  if ( convert == 1)
	  {  float b;
	     fprintf( list_fich," 'B_ISO=b11 to B_ANISO' ");
		  tst_abort((l_atom->x->order !=1 || l_atom->x->order !=1 ),"conversion from B_ISO to B_ANISO needs variable order=1...");
        ini_metric();
        var_init(l_atom->x);
        b = 0.25*var_valeur(4);
		  l_atom->x->value[4] = b*g_aa;
		  l_atom->x->value[5] = b*g_bb;
		  l_atom->x->value[6] = b*g_cc;
		  l_atom->x->value[7] = 0;
		  l_atom->x->value[8] = 0;
		  l_atom->x->value[9] = 0;
	     fprintf( list_fich," B11=%6.4f  B22=%6.4f  B33=%6.4f    b1=b13=b23=0\n", 
		       var_valeur(4), var_valeur(5), var_valeur(6));
		  }
     if (l_phase->modul && l_phase->modul->compo_atom && j >=l_phase->modul->compo_atom )
	  {  current_symgrp = l_phase->modul->compo_sym;
	     lect->sites += atom_site(current_symgrp->nom,l_phase->modul->compo_sym4);
	     current_symgrp = l_phase->symgrp;
		  }	
	  else if ( l_phase->modul ) lect->sites += atom_site(NULL,l_phase->modul->symgrp);
     else if (terme==0) lect->sites += atom_site(NULL,NULL);
     l_phase->nb_par += l_atom->nb;
     if ( l_atom->n_modul )
     {  l_atom->modul=fget_var(l_atom->n_modul*AMODUL, AMODUL, VAR_ORIEN, l_atom->nom,(void *)txt_modul, "MODUL", NULL, 0, 0);
        l_phase->nb_par += l_atom->n_modul * AMODUL;
        }
     if ( l_atom->n_anharm )
     {  if (cas &  B_ANHARM3 )
        {  l_atom->anharm=fget_var(COORD_ANHARM3, 0, VAR_STD, l_atom->nom,(void *)txt_anharm3, "ANHARM3", NULL, 0, 0);
           l_phase->nb_par += l_atom->n_anharm = COORD_ANHARM3;
           }
        if (cas &  B_ANHARM4 )
        {  l_atom->anharm=fget_var(COORD_ANHARM4, 0, VAR_STD, l_atom->nom,(void *)txt_anharm4, "ANHARM4", NULL, 0, 0);
           l_phase->nb_par += l_atom->n_anharm = COORD_ANHARM4;
           }
        if (cas &  B_ANHARM5 )
        {  l_atom->anharm=fget_var(COORD_ANHARM5, 0, VAR_STD, l_atom->nom,(void *)txt_anharm5, "ANHARM5", NULL, 0, 0);
           l_phase->nb_par += l_atom->n_anharm = COORD_ANHARM5;
           }
        if (cas &  B_ANHARM6 )
        {  l_atom->anharm=fget_var(COORD_ANHARM6, 0, VAR_STD, l_atom->nom,(void *)txt_anharm6, "ANHARM6", NULL, 0, 0);
           l_phase->nb_par += l_atom->n_anharm = COORD_ANHARM6;
           }
        }
      }
     else   /* terme == -1 used for amorphous... */
     {   l_atom->nb = 1;  
         check_dif (espece);
         l_atom->x=fget_var(l_atom->nb, 0, VAR_ATOM, l_atom->nom, (void **) txt_atom_amo, "COORD", NULL, 0, 0);
         }
      }
   pop_err_msg();
	return (ret_atom);
   }
/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */


