/* XND_RD.C    read the first data */
static char *cvs_id =" $Id: xnd_rd.c,v 1.3 2002/07/04 12:01:14 berar Exp $ ";

#define USE_VAR
#define USE_SYM
#define USE_EXPER
#define USE_PHASE
#define USE_OBS
#define USE_DIFDAT
#include "../xnd_def.h"
#include "../xnd_mem.h"
#include "../refer.h"

#define  EXTERN_RD
#include "xnd_rdh.h"
/*  --------------------------------------------- */

#include <sys/stat.h>   /* used in get_tmpfile */
#ifdef MAC_OS
#include <unix.h>   
#endif

#include <errno.h>
#ifndef ENOENT
#define ENOENT   2
#endif

/* mode d'ouverture des fichiers */
#ifdef MSDOS
#define R_MODE  "rb"
#define W_MODE  "w+b"
#else
#define R_MODE  "r"
#define W_MODE  "w+"
#endif
/* ------------------------------------------------------------------ */
void make_path(P_(char *)result, P_(char *) path, P_(char *) id)
#ifdef NO_PROTO
char * result;
char * path;
char * id;
#endif
{   char *pos;
    strcpy(result, path);
#ifndef VAXC
    pos = result + strlen(result)-1;
    if (*pos!=END_PATH_STR[0])  strcat(result, END_PATH_STR); 
#endif
    strcat(result, id);
    }
/* ------------------------------------------------------------------ */
/*   pour connaitre le path du programme a l'execution */
/*   ce sous programme est machine dependant           */
void path2prog (P_(void))
{
     char *pos;
#ifdef UNIX_OS
     char * chaine;
     char * prg;
     char  prog[NAME_LG];
#ifndef HPUX_SOURCE
     struct stat  stat_buf;
#else
     char stat_buf[200];    /* why */
#endif
    strcpy (lect->data_path,PROG_PATH);     /* empty path now */
    prg = lect->argc;                       /* name of executable */
    if ( ( prg[0] == '/' )             
      || ( prg[0] == '.' && prg[1] == '/' )
      || ( prg[0] == '.' && prg[1] == '.' && prg[2] == '/' ) ) 
         strcpy (lect->data_path, prg);     /* absolute path */
    else   
    if ( prg[0] == '~' )                  /* path relative to home */
    {    chaine = (char *) getenv ("HOME"); 
         if (chaine != NULL) strcpy (lect->data_path, chaine);
         strcat (lect->data_path, prg+1);
         }
   else   
    {   chaine = (char *) getenv ("PATH"); /* exploring path */
        while (chaine != NULL)
        {   pos = strchr (chaine, ':');
            if (pos != NULL) *pos = 0;
            strcpy (prog, chaine);
            strcat (prog, "/");
            strcat (prog, lect->argc);
            if ( stat (prog , &stat_buf)==0)
            {   strcpy (lect->data_path, prog);
               break;
               }
           if (pos != NULL) chaine = pos + 1; else chaine = NULL;
           }
     }
#else
#ifdef MAC_OS
    strcpy (lect->data_path, "");
#else
    strcpy (lect->data_path, lect->argc);
#endif
#endif
    pos = strrchr (lect->data_path,END_PATH_STR[0]);
    if (pos != NULL) *(pos+1) = 0;
    }
/* ------------------------------------------------------------------ */
void prog_id(P_(char *)string)
#ifdef NO_PROTO
char * string;
#endif
{    char *pos;
#ifdef MSDOS
     strcpy  (string, lect->argc);      return;
#else
#ifdef VAXC
     strcpy  (string, lect->argc);      return;
#else
     strcpy (string, lect->data_path);
#ifndef MAC_OS
     pos = strrchr (lect->argc, END_PATH_STR[0]);
     if (pos == NULL) pos = lect->argc;
    else if ( *(pos+1) != 0) pos++;
#else
     pos = PRG_ID;
#endif

     strcat (string, pos);     return;
#endif
#endif
     }
/* ------------------------------------------------------------------ */
void strup (P_(char *) string)
#ifdef NO_PROTO
char * string;
#endif
{    char *c;
    c = string;
    while (*c !=0)
    {    if (islower(*c)) *c = toupper(*c);
        c++;
    }    }

/* ------------------------------------------------------------------ */
/* avoid fscans to be cancelled by cr                                 */
/* allowing dos files to be used with Sun KK compiler                 */
/* needed also for dos and unix files on mac with CodeWarrior         */
void purge_cr(P_(void))
{     char cr[5];
      push_err_msg("purge_cr(xnd_rd.c)");
      while( fscanf(coord_fich, " %[\r\n]", cr)==1 );
      pop_err_msg();
      }
/* ------------------------------------------------------------------ */
/* traiter les lignes de commentaires en lecture                      */
sint read_remark(P_(char **) remptr)
#ifdef NO_PROTO
char **remptr;
#endif
{  sint lues = 0;
   char line[102];
	int size = 0;
   push_err_msg("read_remark(xnd_rd.c)");
   purge_cr();
   while ( fscanf (coord_fich, " %[#]", line) == 1)
   {  fgets ( &line[1], 100, coord_fich);
      fputs (line, list_fich);
      if (remark_fich != NULL)
      {  fputs (line, remark_fich);
         lues++;
         }
      else if (new_fich != NULL)
      {  fputs (line, new_fich);
         }
		else if (remptr)
      {  size += 2+strlen(line);
        if ( *remptr )
        {  *remptr = (char *) realloc(*remptr, size);
           strcat(*remptr, line);
           }
        else
        {  *remptr = (char *) malloc(size);
           strcpy(*remptr, line);
           }
			}  
      purge_cr();
      }
	pop_err_msg();
   return lues;
   }
/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */
FILE *get_tmpfile (P_(char *) path, P_(char *) name, P_(char *) reason)
#ifdef NO_PROTO
char *path;
char *name;
char *reason;
#endif
{   
#ifndef HPUX_SOURCE
     struct stat  stat_buf;
#else
     char  stat_buf[200];    /* why */
#endif
    char buffer[100];
    int num, result;
    if (path == NULL || strlen(path) == 0)
    {    fprintf(list_fich, " Using system tmpfile for %s\n", reason);
         name[0] = 0;
     return tmpfile();
     }
    make_path(name, path, PRG_ID);
    for (num = result = 0; num < 999; num++ )
    {   sprintf(buffer,"%s_%d.$$$", name, num);
		  result = stat( buffer, &stat_buf );
        if ( result != -1 ) continue;
        if ( errno != ENOENT ) continue;
		  errno = 0;
        strcpy( name, buffer);
        fprintf(list_fich, " Using '%s' as temporary file for %s\n", name, reason);
        return fopen (name, W_MODE);         
        }
   fprintf( stderr," No tmp file found in %s\n", path);
   return get_tmpfile (NULL, name, reason);
   }

/* ------------------------------------------------------------------ */
void clean_remarks(P_(void))
{  int irem;
   push_err_msg("clean_remarks");
	if (lect->rem0) 
	   for (irem = 0; irem <lect->rem_nb; irem++)
	      if (lect->rem0[irem]) free(lect->rem0[irem]);
 	if (lect->rem1) 
	   for (irem = 0; irem <lect->rem_nb; irem++)
	      if (lect->rem1[irem]) free(lect->rem1[irem]);
	lect->rem_nb=0;	
   pop_err_msg();
	}
/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */
void read_init (P_(int) argn, P_(char **) argv)
#ifdef NO_PROTO
int argn;
char **argv;
#endif
{  int    i;
   char   *car;
   long   l;

   hkldata_fich = remark_fich = NULL;
   plg_fich = hkl_fich = new_fich = NULL;
   list_fich = stderr;
   prt_new = 0;
   lect = (LECT *) tst_alloc (1,sizeof(LECT),"Reading");
	memset (lect, 0, sizeof(LECT));
   car = " Usage : '%s [-s] coord_file'\n\n%s\nCoordinates file ? ";
   bavard = 1;
    
   if (argn != 0)
   {  lect->argc = argv[0];
      path2prog ();
      prog_id(lect->prg_name);
      make_path(lect->tmp_path, lect->data_path, DOC_ID);
      }
   else 
   {  strcpy(lect->prg_name,"xnd");
      strcpy(lect->tmp_path,".");
      strcpy(lect->data_path,".");
      }   
   switch (argn)
   {  case 0 :
      case 1 : 
		 printf ("%s : %s [%s:%s]\n", lect->prg_name, xnd_release(), xnd_host(), xnd_kernel());
		 printf (car, lect->prg_name, xnd_ref());
         scanf(" %[^\n]",data_name);
         car = data_name;
         break;
      case 2 : car = argv[1]; break;
      case 3 : car = argv[2];
         if (((i=(argv[1][0]=='-'))!=0)
           && (strchr(argv[1],'s')!=NULL))   bavard = 0;
      }
   if (bavard) printf ("\n %s : %s [%s:%s]\n",
     lect->prg_name, xnd_release(), xnd_host(), xnd_kernel());
   /* trying to open car or car.k files */
   strcpy(lect->coord_name, car);
   coord_fich = fopen ( lect->coord_name, "r");
   if (coord_fich==NULL)
   {  if (strchr(lect->coord_name,'.') == 0)
      {  strcat(lect->coord_name, ".k");
         coord_fich = fopen ( lect->coord_name, "r");
         }
	   if (coord_fich==NULL)
      {  printf(E_FOPEN, "coordinates", car);
         exit (10);
      }  }
    /* read xnd header including old (1.18) ones */
    init_error();
    fgets (titre, NAME_LG-1, coord_fich);
    if (get_12hdr() == 0 && get_11hdr() == 0)
    {  printf(E_HDR, car, lect->coord_name);
       exit(10);
       }
	 if (prt_new && new_12hdr() == 0 ) new_11hdr();	 
	 clean_remarks();
    /* get the programme directory and use it for std file */
    make_path (lect->dif_name, lect->data_path, DIF_FILE);
    fprintf(list_fich," if needed '%s' will be searched\n", lect->dif_name);
    make_path (lect->sym_name, lect->data_path, SYM_FILE);
    fprintf(list_fich," if needed '%s' will be searched\n", lect->sym_name);

    lect->max_points = nt_diag = n_sym = n_dif= n_var =
    n_par = n_pen = lect->nature = tot_prof_par = phase_prof_par = 0;
    lect->tot_points = 0L;
    lect->ini_date = 0;
    for (i=1;i<MAX_COD;i++) lect->codepar[i]=0;

     fflush (list_fich);
    if (lect->nl_sym)
    {   fprintf(list_fich,"\n\nReading %d symetry group(s)\n", lect->nl_sym);
        for (i=0;i<lect->nl_sym;i++)
    {   if (prt_new) fprintf(new_fich,"\n\n");
        read_remark(NULL);
        lect->symgrp[i] = (TYPE_SYMGRP *) read_sym (coord_fich);
        if (lect->prt_sym & 1) print_sym (lect->symgrp[i], 1);
        if (prt_new)    new_sym (lect->symgrp[i]);
        }
    }
   if (lect->nl_ano)
   {  fprintf(list_fich,"\nReading %d anomalous tables\n", lect->nl_ano);
      read_remark(NULL);
      lecture_ano ();
      }
   else lect->anodat = NULL;
   if (lect->nl_dif)
   {  fprintf(list_fich,"\nReading %d diffusion tables\n", lect->nl_dif);
      for (i=0;i<lect->nl_dif;i++)
      {  read_remark(NULL);
         lect->difdat[i] = lecture_dif(coord_fich, NULL);
         if (lect->prt_dif & 1) put_dif (lect->difdat[i], list_fich);
         if (prt_new)     put_dif (lect->difdat[i], new_fich);
         }
      }
   fflush (list_fich);

   read_remark(NULL);
   if (disk_data & 2)      data_init(fopen (data_name, R_MODE), disk_data);
   else if (disk_data & 1) data_init(fopen (data_name, W_MODE), disk_data);
   else {  disk_data = 8;
           data_init(get_tmpfile(lect->tmp_path, data_name, "datafile"), disk_data);
           }

    /* fin d'ecriture du fichier new, on stocke les remarques */
    remark_fich = get_tmpfile(lect->tmp_path, remark_name, "remarks");


    tst_abort ((n_exper<=0), "No experiment to read");
    l_exper = exper = (TYPE_EXPER *) tst_alloc (n_exper,sizeof(TYPE_EXPER),"exper");
    for (i=0;i<n_exper;(i++,l_exper++)) 
    {     l_exper->number = i;
	  lect->nature |= read_exper();
          }

    tst_abort ((n_phase<=0), "No phase to read");
    tot_phase = n_phase;
    l_phase = phase = (TYPE_PHASE *) tst_alloc(n_phase,sizeof(TYPE_PHASE),"phase");
    for (i=0;i<n_phase;i++,l_phase++) read_phase (i);

    end0_remark = read_remark(NULL);

    marquardt = 0; c_marquardt=0;
     fscanf (coord_fich,"%f %d %*lf",&marquardt,&c_marquardt);
     if (marquardt > 1)
     {     fprintf (list_fich,"\n Marquardt parameter is invalid %f, modified", marquardt);
           marquardt = 0.0002;
           c_marquardt = 12;
           }
    fprintf (list_fich,
     "\n starting value of the Marquardt parameter %.3g, decreasing by %d/10\n\n",
     marquardt, c_marquardt);

    end1_remark = read_remark(NULL);

    lect->tot_points += 2*nt_diag;
    fprintf (list_fich,"\n Size of temporary data file : %s %ld ko\n",
        data_name,1 + (long) (sizeof(TYPE_OBS)*lect->tot_points)/1024);

    verbose_printf (" %d variables (%d parameters), %d cycles allowed\n",n_var, n_par, max_cycle);
    fflush (list_fich);

   /* if (n_par==0) max_cycle=0;            */
    if (max_cycle==0) n_par=0;
    n_mat = (n_par * (n_par+1))/2;
	 
	 if ( (l=memory_swap(lect->max_points, n_par, disk_dydp)) )
    {  memory_file( get_tmpfile (lect->tmp_path, dydp_name,"swap file"));
       fprintf (list_fich,"Size of temporary swap file : %ld ko\n",
       l/1024);
       }
    if (lect->nl_ano) free (lect->anodat);
    free (lect);
    bragg_fich = NULL;

    if (n_par)
    {  fini = 0;
       y_vect  = (FLOAT *) tst_alloc (n_par,sizeof(FLOAT),"vecteur");
       matrice = (FLOAT *) tst_alloc (n_mat,sizeof(FLOAT),"matrice");
    }
    else fini = (max_cycle ==0 ) ? 1 : 0;


    if (new_fich) fclose (new_fich);
    fclose (coord_fich);
    pop_err_msg();
    }
/* ------------------------------------------------------------------ */

