static char *cvs_id =" $Id: xnd_mat.c,v 1.2 2002/01/10 15:24:45 berar Exp $ ";
/* XND_MAT      inversion des matrices  et divers math */

#include "../xnd_def.h"

static int n_zero = 0;

void inverse(P_(float) ratio)
#ifdef NO_PROTO
float ratio;
#endif
{    int result = 0;
     int i,j;
     FLOAT *mat;
     push_err_msg("Inverting matrix(xnd_mat.c)");
     for (i=1,mat=matrice;i<=n_par;mat+=i++)
     {   if (test_mode & 0x1)
	      {    fprintf(list_fich,"VECT[%d] %10.3g MAT", i-1, y_vect[i-1]);
	           for (j=0; j<i;j++) fprintf(list_fich,"%s %2d %10.3g",j%5==0?"\n":"",j,mat[j]);
	           fprintf(list_fich,"\n");
	           }
	      if ( fabs(mat[i-1]) < MINFLOAT )
         {    if (result++ == 0)
			     {    fprintf(list_fich," Null diagnonal element(s) ==> blocking parameter(s)");
	                if (bavard) printf("Null diagnonal element(s) ==> blocking parameter(s)");
						 }
			     fprintf(list_fich," #%d%s",i, result%20==5?"\n":"");
	           if (bavard) printf(" #%d%s",i, result%20==5?"\n":"");
              y_vect[i-1] = 0;
              mat[i-1] = 1;
              }
         else if (marquardt>0) *mat *= 1+marquardt;
         }
     if (result)
	  {   fprintf(list_fich,"\n %d parameters are fixed\n", result);
	      if (bavard)
			{   printf("\n");
	          if (result>5) printf("%d parameters are fixed\n", result);
				 }
         if  (  result >= n_par ) termine (11, "too much fixed parameters in the matrix\n"); 
         if  (  result >= n_par ||( ratio > 10 && result > n_zero))
     	   {   fprintf(list_fich, "\n  ratio %f zero %d previous %d n_par %d\n", 
     	            ratio, result, n_zero, n_par);
     	       termine (11, "too much fixed parameters in the matrix in divergent system\n"); 
     	   }   }
     n_zero = result;
     result = chol_part (matrice, y_vect, n_par);
     if (test_mode & 0x1)
     for (i=1,mat=matrice;i<=n_par;mat+=i++)
     {   fprintf(list_fich,"RVECT[%d] %10.3g MAT-1", i-1, y_vect[i-1]);
	 for (j=0; j<i;j++) fprintf(list_fich,"%s %2d %10.3g",j%5==0?"\n":"",j,mat[j]);
	 fprintf(list_fich,"\n");
	 }
     if (result)
     {   fprintf (list_fich,
     "  Matrix diagnonal element is zero, parameter #%d\n",result);
	 termine (11, "inverting matrix\n");
	 }
     pop_err_msg();
     }

/* ---------------------------------------------------------------- */
int chol_part (P_(FLOAT *) mat, P_(FLOAT *) vect, P_(int) n)
#ifdef NO_PROTO
FLOAT *mat;
FLOAT *vect;
int n;
#endif
    /* perform Choleski decomposition : M = A * D * tA
       with A(i,i=1) ,j>i=>A(i,j)=0 and D diagonal;
       as result  M-1 = tB * D-1 * B with B = A-1
       the input matrix is symetrical and must be defined
       the storage requirements are minimized
       the input matrix is given as its low triangular part A(i,j) i<=j
       cf L.Leon,F.Millet in TurboC mathematiques p190-193, Eyrolles(Paris) 1988
       */
{   register i, j, k;
    int ret_val = 0;
    FLOAT  **rmat;
    double **amat;
    double *vtab, *dtab;
    push_err_msg("chol_part(xnd_mat.c)");
    /* this define minimize the storage requirements */
#define bmat  amat
#define new_b vtab
    /* array of ptr on the lines of the low triangular part of mat */
    rmat = (FLOAT **) tst_alloc (n,sizeof(FLOAT *),"inversion 0");
    for (i=0; i<n; i++) rmat[i] = mat + ((i * (i+1)) / 2);
    /* array of ptr's on allocated lines of a low triangular array */
    amat = (double **) tst_alloc (n,sizeof(double *),"Inversion 1");
    for (i=0; i<n; i++) amat[i] = 
         (double *) tst_alloc (i+1,sizeof(double),"Inversion 2");
    /* array of values */
    vtab = (double *) tst_alloc (n,sizeof(double),"Inversion 3");
    dtab = (double *) tst_alloc (n,sizeof(double),"Inversion 4");
    bmat[0][0] = 1;
    amat[0][0] = 1;
    dtab[0] = rmat[0][0];
    if (fabs (dtab[0]) > MINFLOAT )
    {   /* calculate D and A values */
	for (k=1; k<n; k++)
	{   for (i=0, dtab[k] = rmat[k][k]; i<k; i++)
	    {   for (j=0, vtab[i]=0; j<=i; j++)
		   vtab[i] += bmat[i][j] * rmat[k][j];
		amat [k][i] = vtab[i] / dtab[i];
		dtab[k] -= amat[k][i] * vtab[i];
		if (fabs(dtab[k]) < MINFLOAT) ret_val = k+1;
		}
	    /* calculate B values */
	    if (ret_val==0)
	    {   for (i=0; i<k; i++)
		    for (j=i, new_b[i]=0; j<k; j++)
		       new_b[i] -= bmat[j][i] * amat[k][j];
		for (i=0; i<k; i++) bmat[k][i] = new_b[i];
		amat [k][k] = 1;
	        }      
            }
	    /* calculate the lower part of the original matrix */
	    for (j=0; j<n; j++)
	     for (i=0; i<=j; i++)
	      for (k=j, rmat[j][i]=0; k<n; k++)
	       rmat[j][i] += bmat[k][i] * bmat[k][j] / dtab[k];
	    /* le second membre */
	    for (i=0;i<n;i++)
	    {  for (j=0,vtab[i]=0;j<i;j++) vtab[i] += rmat[i][j] * vect[j];
	       for (j=i;j<n;j++)           vtab[i] += rmat[j][i] * vect[j];
	       }
	    for (i=0;i<n;i++) vect[i] = vtab[i];
	    }
	else ret_val = 1;
	free(dtab);
	free(vtab);
	for (i=n-1; i>=0; i--) free (amat[i]);
	free(amat);
	free(rmat);
	pop_err_msg();
	return(ret_val);
	}
/* ---------------------------------------------------------------- */
float poly_f (P_(float *) x, P_(int) deg, P_(float *) coef)
#ifdef NO_PROTO
float *x;
int deg;
float *coef;
#endif
{   int i;
	float *c;
	float val;
	c = coef + deg;
	val = *c;
	for (i=deg; i>0; i--) val = val * *x + *--c;
	return (val);
	}
/* ---------------------------------------------------------------- */
float  sqr(P_(float) x)
#ifdef NO_PROTO
float x;
#endif
{    return (x*x);    }
/* ---------------------------------------------------------------- */
float  fsrand(P_(void))
{   float x;
    x  = rand();
    x /= RAND_MAX;
    x -= floor(x);
    return (x);    }

/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */


