static char *cvs_id =" $Id: xnd_met.c,v 1.2 2002/01/10 15:24:45 berar Exp $ ";
/* XND_MET.C metrique */

#define USE_VAR
#define USE_MODUL
#define USE_PHASE
#include "../xnd_def.h"
#include "../xnd_cah.h"

/* -----------   metric calculation -------------------------- */
static float  a_par,b_par,c_par,det;
static float  cosa,cosb,cosc,sina,sinb,sinc;
static float  cosab_c,cosbc_a,cosac_b;
float ini_metric (P_(void))
{  float n;
/*   if (l_phase->nature == PHASE_AMORPHE) return 1.0;*/
   var_init(l_phase->cell);
   a_par = var_valeur(1);
   if ( l_phase->nature == PHASE_QUASI ) 
   {  if (a_par > 0) g_aa = 1.0 / (a_par*a_par);
      b_par = var_valeur(2);
      if (b_par > 0) g_bb = 1.0 / (b_par*b_par);
      return (a_par);
      }
   b_par = var_valeur(2);
   c_par = var_valeur(3);
   cosa = cos ( RAD * var_valeur(4));
   if (fabs(cosa) <EPSILON) cosa = 0;
   sina = sqrt ( 1.0 - cosa * cosa);
   cosb = cos ( RAD * var_valeur(5));
   if (fabs(cosb) <EPSILON) cosb = 0;
   sinb = sqrt ( 1.0 - cosb * cosb);
   cosc = cos ( RAD * var_valeur(6));
   if (fabs(cosc) <EPSILON) cosc = 0;
   sinc = sqrt ( 1.0 - cosc * cosc);
   d_aa = a_par*a_par;
   d_bb = b_par*b_par;
   d_cc = c_par*c_par;
   d_ab = 2 * a_par*b_par*cosc;
   d_ac = 2 * a_par*c_par*cosb;
   d_bc = 2 * b_par*c_par*cosa;
   det= 1+2*cosa*cosb*cosc-cosa*cosa-cosb*cosb-cosc*cosc;
   g_aa = sqr(sina/a_par) /det;
   g_bb = sqr(sinb/b_par) /det;
   g_cc = sqr(sinc/c_par) /det;
   g_ab = (cosab_c = 2*(cosa*cosb-cosc)) /(a_par*b_par*det);
   g_ac = (cosac_b = 2*(cosc*cosa-cosb)) /(a_par*c_par*det);
   g_bc = (cosbc_a = 2*(cosb*cosc-cosa)) /(b_par*c_par*det);
   if ( det > 0 ) cell_volume = sqrt(d_aa*d_bb*d_cc*det);
	else cell_volume = -1.0;
	/* component of a,b,c	*/	
    na_b = g_ab * g_ac - 2 * g_cc * g_bc;
    nb_b = 4 * g_aa * g_cc -  g_ac * g_ac;
    nc_b = g_ab * g_ac - 2 * g_aa * g_bc;
    n =  (na_b * g_aa + nb_b * g_ab + nc_b * g_ac) * na_b;
    n += (nb_b * g_bb + nc_b * g_bc) * nb_b + nc_b * nc_b *g_cc;
    n = sqrt (n);
    na_b /= n;
    nb_b /= n;
    nc_b /= n;
	return (cell_volume);
   }
/*  ---------------------------------------------------------------- */
/*  pour chaque raie en utilisant :
    dg_aa/da = -2g_aa/a;          dg_ab/da = -g_ab/a;
    dg_bb/da = 0;                 dg_bc/da = 0;
/*  ---------------------------------------------------------------- */
void ini_d_metric (P_(void))
{   float dt_dq;
    float d_det, ss;
    push_err_msg("ini_d_metric");
    switch  ( l_phase->nature )
    {   case  PHASE_PARASITE : 
              /* direct dans xnd_cal.c car pas de maille */
              break;
        case  PHASE_QUASI : 
              dt_dq = 0.5 / RAD * tan_t / q;
              d_metric[0] = - dt_dq * 2 * g_aa * h_eff / a_par;
              if (b_par > 0 ) d_metric[1] = - dt_dq * 2 * g_bb * l_eff / b_par;
              break;
        default :
        dt_dq = 0.5 / RAD * tan_t / q;
        d_metric[0] = - dt_dq * h_eff * (2*h_eff*g_aa + k_eff*g_ab + l_eff*g_ac) / a_par;
        d_metric[1] = - dt_dq * k_eff * (2*k_eff*g_bb + h_eff*g_ab + l_eff*g_bc) / b_par;
        d_metric[2] = - dt_dq * l_eff * (2*l_eff*g_cc + l_eff*g_ac + k_eff*g_bc) / c_par;
        d_det = sina * cosbc_a / det;
        ss = h_eff*h_eff*g_aa*cosa/sina;
        ss += sina*(k_eff*l_eff/(b_par*c_par) - h_eff*(k_eff*cosb/b_par + l_eff*cosc/c_par)/a_par)/det;
        d_metric[3] = RAD * dt_dq * (ss + q * d_det);
        d_det = sinb * cosac_b / det;
        ss = k_eff*k_eff*g_bb*cosb/sinb;
        ss += sinb*(h_eff*l_eff/(a_par*c_par) - k_eff*(h_eff*cosa/a_par + l_eff*cosc/c_par)/b_par)/det;
        d_metric[4] =  RAD * dt_dq * (2*ss + q * d_det);
        d_det = sinc * cosab_c / det;
        ss = l_eff*l_eff*g_cc*cosc/sinc;
        ss += sinc*(h_eff*k_eff/(a_par*b_par) - l_eff*(h_eff*cosa/a_par + k_eff*cosb/b_par)/c_par)/det;
        d_metric[5] = RAD * dt_dq * (ss + q * d_det);
        if ( l_phase->vector && l_phase->vector->dim >=1 ) ini_d_vector( dt_dq );
        }
    pop_err_msg();
    }
/* ------------------------------------------------------- */
/* valeurs et derivees dans reseau direct pour contraintes */
float  scalaire (P_(float *)u, P_(float *)gv, P_(float *)v)
#ifdef NO_PROTO
float *u, *gv, *v;
#endif
{  float d;
    int j;
    gv[0] = d_aa * v[0] + (d_ab * v[1] + d_ac * v[2]) /2;
    gv[1] = d_bb * v[1] + (d_bc * v[2] + d_ab * v[0]) /2;
    gv[2] = d_cc * v[2] + (d_ac * v[0] + d_bc * v[1]) /2;
    d=0;
    for (j=0;j<3;j++) d += u[j] * gv[j];
    return (d);
    }

/*  --------------------------------------------- */
float  u_equiv (P_(TYPE_VAR *)x, P_(float *)uij)
#ifdef NO_PROTO
VAR *x;
float *uij;
#endif
{  float u_iso, *v, r_a, r_b, r_c;
   float mij[6];
   ini_metric();
   var_init(x);
   v = (uij == NULL) ? mij : uij;
   r_a = sqrt(g_aa);
   r_b = sqrt(g_bb);
   r_c = sqrt(g_cc);
	v[0] = var_valeur(4) / (2*M_PI*M_PI) / g_aa;
   v[1] = var_valeur(5) / (2*M_PI*M_PI) / g_bb;
   v[2] = var_valeur(6) / (2*M_PI*M_PI) / g_cc;
   v[3] = var_valeur(7) / (2*M_PI*M_PI) / (r_a*r_b);
   v[4] = var_valeur(8) / (2*M_PI*M_PI) / (r_a*r_c);
   v[5] = var_valeur(9) / (2*M_PI*M_PI) / (r_b*r_c);
   u_iso = v[0]*a_par*a_par*g_aa + v[1]*b_par*b_par*g_bb + v[2]*c_par*c_par*g_cc;
	u_iso += v[3]*a_par*b_par*r_a*r_b + v[4]*a_par*c_par*r_a*r_c + v[5]*b_par*c_par*r_b*r_c;
   u_iso /= 3.0;
   return (u_iso);
   }
/*  --------------------------------------------- */
float d_dmetric (P_(int) j, P_(float *)u, P_(float *)v)
#ifdef NO_PROTO
int j;
float *u, *v;
#endif
{  switch (j)
   {   case 1 : return ( u[0] * v[0] * d_aa + (u[0]*v[1]+u[1]*v[0])*d_ab + (u[0]*v[2]+u[2]*v[0]*d_ac) / a_par);
       case 2 : return ( u[1] * v[1] * d_bb + (u[0]*v[1]+u[1]*v[0])*d_ab + (u[1]*v[2]+u[2]*v[1]*d_bc) / b_par);
       case 3 : return ( u[2] * v[2] * d_aa + (u[2]*v[1]+u[1]*v[2])*d_bc + (u[0]*v[2]+u[2]*v[0]*d_ac) / c_par);
       case 4 : return ((u[2]*v[3]+u[3]*v[2]) * b_par *c_par * sinc * RAD);
       case 5 : return ((u[2]*v[3]+u[3]*v[2]) * b_par *c_par * sinc * RAD);
       case 6 : return ((u[2]*v[3]+u[3]*v[2]) * b_par *c_par * sinc * RAD);
       }  
    return 0;
    }
    
/* ---------------------------------------------------------- */
