static char *cvs_id =" $Id: xnd_var.c,v 1.2 2002/01/10 15:24:45 berar Exp $ ";
/* XND_VAR.C */

#define USE_VAR
#include "../xnd_def.h"

/* --------- specific public declaration --------- */

TYPE_VAR    *current_var;    /* used also in xnd_vio.h */
int    var_order;
int    var_dim;
int    var_io;
int    var_id;
int    var_number;
int    do_save = 0;          /* allow to save current values */
/* --------- this function must be called before values... --------- */
/* change from macro VAR_init to function in 1.19 allows indirection */
TYPE_VAR* var_init (P_(TYPE_VAR *) var)
#ifdef NO_PROTO
TYPE_VAR *var;
#endif
{  if((current_var=var)!=NULL)
   {  var_order=current_var->order;
      var_dim=current_var->dim;
      var_number=current_var->number;
      }  else
   var_order=var_dim=var_number=0;
   return var;
   }
/* --------- can replace var_init to check if derivatives ---------- */
int var_ideriv (P_(TYPE_VAR *) var)
#ifdef NO_PROTO
TYPE_VAR *var;
#endif
{  if((current_var=var))
   {  var_order=current_var->order;
      var_dim=current_var->dim;
      var_number=current_var->number;
      return var->npar;
		}  else
   var_order=var_dim=var_number=0;
   return 0;
   }
/* --------- values of parameters and their derivatives --------- */
float var_valeur (P_(int) pos)
#ifdef NO_PROTO
int pos;
#endif
{   int i=1;
    float par=1;
    float val;
    float *v;
    if (var_order==0) return(0);
    v = current_var->value + var_order*pos;
    val = *v;
    while (i++<var_order) val += *(++v) * (par *= *temp);
    return(val);
    }
/* ------------------------------------------------------------------ */
static int ex_pos;
static int ex_par;
/* ------------------------------------------------------------------ */
int var_param (P_(int) pos)
#ifdef NO_PROTO
int pos;
#endif
{   if (var_order==0 || var_io > var_order) return(0);
    ex_pos = var_order*pos+var_io;
    ex_par = ex_pos*var_dim+var_id;
    return (current_var->param[ex_par]);
    }
/* ------------------------------------------------------------------ */
float var_derive (P_(void))
{   int i;
    float val=1;
    if (var_order==0) return(0);
    for (i=1;i<=var_io;i++) val *= i * *temp;
    return (val * current_var->shift[ex_par]);
    }
/* ------------------------------------------------------------------ */
float var_shift (P_(void))
{   if (var_order==0) return(0);
    return (current_var->shift[ex_par]);
    }
/* ------------------------------------------------------------------ */
float var_new (P_(float *) deplace)
#ifdef NO_PROTO
float deplace;
#endif
{   if (var_order==0) return(0);
    if (do_save) current_var->saved[ex_pos] = current_var->value[ex_pos];
	 if (current_var->relax) *deplace *= current_var->relax;
	 current_var->value[ex_pos] = current_var->saved[ex_pos] + *deplace;
    return (current_var->value[ex_pos]);
    }
/* ------------------------------------------------------------------ */
float var_allowed(P_(float) deplace,P_(int *)code)
#ifdef NO_PROTO
float deplace;
#endif
{   float a, allowed = 1.0;
    *code = 0;
    if (var_order==0) return(0);
    if (do_save) current_var->saved[ex_pos] = current_var->value[ex_pos];
    if (current_var->relax) deplace *= current_var->relax;
	 if (current_var->mode & VAR_MODE_GT0)
       if (5*deplace + 4*current_var->saved[ex_pos] < 0 )
       {    allowed = -0.80 * current_var->saved[ex_pos]/deplace ;
            if (current_var->relax) allowed /= (current_var->relax*current_var->relax);
	         *code |= VAR_MODE_GT0;
	         }
	 if (current_var->mode & VAR_MODE_ABS && current_var->allow_shift)
      if ( fabs(deplace) > current_var->allow_shift )
      {    float a = current_var->allow_shift/fabs(deplace);
           if (a < allowed ) allowed = a;
           *code |= VAR_MODE_ABS;
	        }
	 if (ex_pos == 3 && current_var->mode & VAR_MODE_OCC)
       if (5*deplace + 4*current_var->saved[ex_pos] < 0 )
       {    allowed = -0.80 * current_var->saved[ex_pos]/deplace ;
            if (current_var->relax) allowed /= (current_var->relax*current_var->relax);
	         *code |= VAR_MODE_OCC;
	         }
    return allowed;
    }
/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */

