static char *cvs_id =" $Id: xnd_main.c,v 1.1.1.1 2001/07/27 13:08:00 berar Exp $ ";
/* XND_MAIN.C  module contenant le programme principal */

#define USE_RPRO
#define USE_RBRG
#define USE_BRAGG
#define USE_VAR 
#define USE_ATOM
#define USE_SETS
#define USE_PHASE
#define USE_PSEUDO

#define EXTERN     /* cree les variables */
#include "xnd_def.h"
#include "xnd_cah.h"
#include "xnd_snh.h"
#include "xnd_mem.h"

#include <string.h>

#ifndef _INCLUDE_HPUX_SOURCE
#include <time.h> 
#endif

#ifdef MSDOS
extern unsigned _stklen = 0x2000;
#endif

#ifdef MAC_OS
#include <console.h>
#endif

/* ------------------------------------------------------------------ */
TYPE_PHASE  *phase;
TYPE_PHASE  *l_phase;
/* ------------------------------------------------------------------ */
TYPE_RPRO indic;                 /* overall sums */
FLOAT t_pen, t_sng, t_eff;
int n_tot, nt_par;

#if defined ( __STDC__ ) || defined ( MAC_OS )
time_t secs_now;
static time_t secs_start;
static clock_t clock_start;
clock_t clock_min, clock_now;
static clock_t clock_cal, clock_inv, clock_prt, clock_ini;
#else
long  secs_now;
static long  secs_start;
static long clock_start;
long clock_min, clock_now;
static long clock_cal, clock_inv, clock_prt, clock_ini;
#endif

/* ------------------------------------------------------------------ */
void exper_loop PROTO((void));
void min_lin PROTO((void));
void history PROTO((void));
void resize_history PROTO((int n_par0));

void cif_out PROTO((TYPE_RPRO *indic, int nt_par, int npen));
void os_chk_abort PROTO((void));
/* ------------------------------------------------------------------ */
#ifdef XND_WIN32
int w32_argn;
#endif
int main (P_(int) argn, P_(char **) argv)
#ifdef NO_PROTO
int argn;
char **argv;
#endif
{   int i, j;
    FLOAT sum0, summ;
#ifdef XND_WIN32
    w32_argn= argn;
#endif

    clock_start=clock();
    time (&secs_start);
    str_time= ctime(&secs_start);
    clock_cal= clock_inv= clock_min= clock_prt= 0;
    clear_err_msg();
    host = getenv("HOST");
	 if (!host) host ="";
	 read_init (argn, argv);                    /* read data now */
    ini_back_ground();
    ini_pseudo_phase();
    clock_ini=clock()-clock_start;
 
	 nt_par = n_par;
    for (cycle=0; cycle<=max_cycle;cycle++)
    {   clear_err_msg();
        if (cycle==max_cycle) fini=1;
      if (fini==0)
      {   memset (y_vect,0,n_par*sizeof(FLOAT));
          memset (matrice,0,n_mat*sizeof(FLOAT));
          }
      else
      {  if (cycle!=0)
         {  if (prt_cor) prt_correl ();
            free (y_vect);
            free (matrice);
            }
         prt_u_equiv();
#ifdef  OS_CHECK_ABORT
	 os_chk_abort();
#endif
        brg_ini_residual(&o_brg);
        if (prt_hkl) hkl_fich = tst_open (hkl_name,"w","HKL file");
        if (prt_plg) plg_fich = tst_open (plg_name,"w","PLG file");
        }
      minli = 0;
      clock_now=clock();
      exper_loop ();
      if (cycle==0) sum0 = summ = t_eff;
      else if (t_eff < summ) summ= t_eff;

      if (fini) { clock_prt+=clock()-clock_now; break; }
      clock_cal+=clock()-clock_now;
    if (n_par  ) {    
	    clock_now=clock();
       if (cycle >= 1) inverse (t_eff/xt_eff); else inverse ((FLOAT) 0);
       clock_inv+=clock()-clock_now;

    history();

    if (((mod_lsq & 1)!=0) || ((cycle >= 1) && (t_eff > xt_eff))) min_lin();
    else  for (i=0; i<n_par; i++)  y_vect[i] *= relax;
       } /* if (n_par */
    xt_eff = t_eff;
	 if (auto_intensity == 0 ) imprime (n_par &&(minli==0||minli==-1), 1, minli==0);
    else 
	 {   int s, p, n, n_par0 = n_par;
	     imprime( n_par &&(minli==0||minli==-1), 0, minli==0);
        for (p=0,l_phase = phase;p<n_phase;p++,l_phase++)
        for (s=0,current_sets = l_phase->sets; s<l_phase->nb_sets; s++, current_sets++) 
		  if (current_sets->nb_hkl > 0  && current_sets->auto_intensity == 1)
        {   n_par += n = var_par_set( current_sets->intensity, 0, current_sets->nb_hkl, 1);
            nt_par += n;
				n_var += n;
				l_phase->n_var +=n;
				fprintf(list_fich, "\n Creating %d vars for set %d : n_var = %d, n_par = %d\n", 
				   current_sets->nb_hkl, s, n_var, n_par);
	         } 
		 if (n_par != n_par0 )
		 {   memory_adjust(n_par);		 
		     n_mat = (n_par * (n_par+1))/2;
			  resize_history(n_par0);
			  }
		 auto_intensity = 0;
		 }
   fflush(list_fich);
#ifdef  OS_CHECK_ABORT
	 os_chk_abort();
#endif

    if (c_marquardt!=0 && marquardt>MINFLOAT && cycle!=0)
    {    if (t_eff > xt_eff) marquardt *= 0.2*c_marquardt;
         else marquardt /= 0.1*c_marquardt;
         fprintf (list_fich, " New Marquardt coefficient = %.3g\n",marquardt);
         }
    }   /* cycle */
    if (prt_hkl) hkl_fich = xclose(hkl_fich);
    if (prt_plg) plg_fich = xclose(plg_fich);

    brg_fprintf (list_fich, "\n Overall ", &o_brg);
    if (bavard) brg_fprintf (stdout, " Overall ", &o_brg);

    memory_close();
    if (prt_cif && prt_cif != -1)  cif_out( &indic, nt_par, n_pen);

    if (prt_new) 
	 {  xt_eff = t_eff; 
	    new_cdr (); 
		 }
          
	 /* status code to return */
	 if (max_cycle == 0) termine (0,"");
    if (t_eff == summ)  i = 0;
    else if (t_eff < sum0) i = 1;
    else  i = 2;
    if (cycle >= max_cycle) i +=3;
    termine (i, "");
    return 0;
	 }

/* ------------------------------------------------------------------ */
/*  if required by the operating system in order to properly abort    */
/*  the directory is writen and agrees with the content of the file   */
#ifdef  OS_CHECK_ABORT
void os_chk_abort(P_(void))
{	 list_fich = freopen (list_name,"at",list_fich);
	 if (list_fich == NULL)
	 {    printf ("Reopen failed on '%s'\n",list_name);
			exit (10);
			}
	  }
#endif
/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */
FILE * xclose (P_(FILE *) file)
#ifdef NO_PRPOTO
FILE *file;
#endif
{    if (file != NULL) fclose (file);
     return NULL;
     }
/* ------------------------------------------------------------------ */
void termine (P_(int) cas, P_(char *) msg)
#ifdef NO_PROTO
int cas;
char *msg;
#endif
{   char texte[200];
    time (&secs_now);
    clock_now=clock()-clock_start;
    str_time = ctime (&secs_now);
    if ( cas >= 10 && cas != 13 ) dump_err_msg();
    verbose_printf ("%s %s\n Duree %lds STOP %d, %s\n",
		 cas<10?"":ERROR, msg, secs_now-secs_start,
		 cas, str_time);
    verbose_printf (
" CPU usage :\n %9s=%.2fs  %9s=%.2fs   %9s=%.2fs\n %9s=%.2fs  %9s=%.2fs   %9s=%.2fs\n",
	 "total", clock_now*CLOCK_UNIT, 
	 "reading", clock_ini*CLOCK_UNIT, 
	 "printing",clock_prt*CLOCK_UNIT,
	 "inverting",clock_inv*CLOCK_UNIT,
	 "min_li",clock_min*CLOCK_UNIT,
	 "cal_deriv",clock_cal*CLOCK_UNIT);
    memory_close();
    plg_fich = xclose (plg_fich);
    hkl_fich  = xclose (hkl_fich);
    bragg_fich = xclose(bragg_fich);
 	 cif_fich = xclose(cif_fich);
    data_close();
    /* on efface si necessaire le fichiers temporaires */
    if (dydp_name && strlen(dydp_name))     unlink (dydp_name);
    if (remark_name && strlen(remark_name)!=0) unlink (remark_name);
    if (data_name && strlen(data_name) && (disk_data==2 || disk_data==8))
        unlink (data_name);
#ifdef XND_WIN32
   if (w32_argn <= 1)
   {  char buf[80];
      buf[0]=0;
      verbose_printf("\nWIN32 : waiting for Enter(s) in the window on keyboard\n");
      gets(buf);  buf[0] = 0; gets(buf);
      }
#endif
    fclose (list_fich);
    exit (cas);
    }
/* ------------------------------------------------------------------ */
/* ---------------------------------------------------------- */
int fprt_indic (P_(TYPE_RPRO *) indic, P_(int) cas)
#ifdef NO_PROTO
TYPE_RPRO *indic;
int cas;
#endif
{  FLOAT rwp,rp,rwp_cor,re,ren,d_val,chi;
   FLOAT rwp_b, rp_b;
   char texte[100];
   if (indic->so_wp < EPSILON) return;
   rwp = sqrt (indic->sd_wp/indic->so_wp);
   rwp_cor = sqrt (indic->sd_wp_cor/indic->so_wp);
   rp = indic->sd_p/indic->so_p;
   if (indic->so_wp_b > EPSILON)
   {  rwp_b = sqrt(indic->sd_wp_b/indic->so_wp_b);
      rp_b = indic->sd_p_b/indic->so_p_b;
      }  else rwp_b = rp_b = 0;
   if (cas) ren = indic->s_n + n_pen - nt_par;
   else    ren =  indic->s_n + (n_pen - nt_par)/ (FLOAT) nt_diag;
   re = sqrt (ren/indic->so_wp);
   d_val = indic->d_val / indic->sd_wp;
   chi = rwp/re;
   sprintf (texte,
      " Rwp=%.4f  Rp=%.4f  Rwp_c=%.4f  GoF=%.2f  (Rwp_b=%.4f Rp_b=%.4f)\n",
      rwp, rp, rwp_cor, chi, rwp_b, rp_b);
   if ((cas!=0) && (minli==0)) fprintf (list_fich,"\n");
   fprintf (list_fich,"%s",texte);
   if ((cas!=0) && (minli==0)) fprintf (list_fich,
" SwDi2=%.5g SwIo2=%.5g SDi=%.5g SIo=%.5g  SwDp_c=%.5g\n\
 SwDi2_b=%.5g SwIo2_b=%.5g SDi_b=%.5g SIo_b=%.5g  N_b=%d\n\
 Rexp=%.3f  d-2=%.2f  Ne=%.0f  N=%d\n",
    indic->sd_wp,indic->so_wp,indic->sd_p,indic->so_p,indic->sd_wp_cor,
    indic->sd_wp_b,indic->so_wp_b, indic->sd_p_b,indic->so_p_b,indic->s_n_b,
    re,d_val-2,ren,indic->s_n); 
   if (cas && bavard) printf ("%s",texte );
   return ren;
	}
/* ---------------------------------------------------------- */


