/* $Id: xnd_t_pseudo.h,v 1.1.1.1 1999/11/21 08:37:00 berar Exp $ */
/* xnd_t_pseudo.h    header for keys usage           */
/* --------------------------------------------- */
#ifndef  XND_T_PSEUDO_H_INCLUDED  /* included once only */
#define  XND_T_PSEUDO_H_INCLUDED
/*  XND_IPH.H   header for modules using the pseudo_phases */
/* --------------------------------------------- */

/* in modulated phases , pseudo phases are created for satelites  */
/* relation between phases and the modulated ones are defined  in */
/* pseudo_phase structure, it contains also function refererences */
typedef enum {PS_DUMMY, PS_STD, PS_MAGNET} PS_CASE;
typedef struct
{    PS_CASE   ps_case;
     int       reference;
     int       fhkl_mult;
     PHASE_PTR  phase;
     SATEL_PTR  satel;
     MODUL_PTR  modul;
	  SETS_PTR   sets;
     SYMGRP_PTR symgrp;
     char      *txt;
     int   (*fhkl_eff)     PROTO((int pos));
     float (*cell_fhkl)    PROTO((void));
     void  (*hkl_eff)      PROTO((void));
     void  (*gen_holoedre) PROTO((void));
     void  (*genget_hkl)   PROTO((void));
     int   (*multiplicity) PROTO((void));
     int   (*basic_mult)   PROTO((void));
     int   (*extinction)   PROTO((void));
     }         TYPE_PSEUDO;
     
EXTERN TYPE_PSEUDO  *pseudo_phase;
EXTERN TYPE_PSEUDO  *l_pseudo_phase;

EXTERN int    prt_modsize;
EXTERN int    bragg_size;
/*  --------------------------------------------- */
/* in XND_IPS.C  phases initialisation */
void ini_pseudo_phase PROTO((void));
/*  --------------------------------------------- */
/* in XND_BRG.C  R_Bragg */
void residu_hkl PROTO((void));
/*  --------------------------------------------- */
/* in XND_HKL.C :  structure factors, gen hkl     */
void gen_hkl PROTO((void));
void get_hkl PROTO((void));
/* functions modified by modulated structure */
void hkl_std PROTO((void));
/* functions modified by magnetic structure */
float  cell_fsum (P_(void));
/*  --------------------------------------------- */
/* in XND_MOD.C : magnetic or modulated structure factors */
void hkl_modul    PROTO((void));
void genget_mod   PROTO((void));
void genget_mag   PROTO((void));
/*  --------------------------------------------- */
/*  --------------------------------------------- */
/* in XND_SYM4.C : bravais symmetry                */
int ini_4D_extinction PROTO((TYPE_PSEUDO * local_pseudo));
/*  --------------------------------------------- */
/* --------------------------------------------- */
#endif          /*  XND_T_PSEUDO_H_INCLUDED        */
/* --------------------------------------------- */

